//LoadRegionFromFile.h - Specification for the associated class.

#ifndef LoadRegionFromFile_h
#define LoadRegionFromFile_h

/*
#include "EnumeratedVolume.h"
#include "ContainmentRegion.h"
#include "ExpansionTemplate.h"
#include "TargetMotionData.h"
#include <vector>
*/


/* =======================================================================================
	The LoadRegionFromFile is used to load test data about a target containment regions which
	exist within the given ocean region.

	This software was developed as part of a grant by ONR 311, Office of Naval Research, 
	800 North Quincy Street, Arlington, Virginia 22217, for development of an "Application 
	of Volume Modeling Techniques to Dynamic Containment Regions for Naval Applications".
	Grant was awarded to Arizona State University, Department of Computer Science and Engineering,
	Dr. Greg Nielson and Gary Graf.


	Author: Gary Graf, Arizona State University.
	Version:  1.0b, 27 Jun 2002

  All rights reserved.
  
	Notes:
=========================================================================================*/


/*!The LoadRegionFromFile is used to load test data about a target containment regions which
	exist within the given ocean region.
*/

class CLoadRegionFromFile
{
/***************************  Public class varibles **************************************/	
public:
	//!filename
	char* fileName;
	//!sourceName
	char* sourceName;
	//!numVerts
	int numVerts;
	//!vertexList (x,y,z)
	float (*vertexList)[3];
	//!numTriangles
	int numTriangles;
	//!trianglesList (x,y,z)
	int (*triangleList)[3];
	//!minLat
	float minLat;
	//!maxLat
	float maxLat;
	//!minLon
	float minLon;
	//!maxLon
	float maxLon;

/***************************  Public  methods ********************************************/
public:
		//Constructors and destructors


	/*!
		Simple constructor.  The act of instantiation simultaneously loads the data from
			the file specified.

		@param fileName - A pointer to a character string which identifies the file to be 
				loaded into memory.
	*/
	CLoadRegionFromFile(char*);


		//Destructor
	~CLoadRegionFromFile();

};	//end class CLoadRegionFromFile specifications
#endif
