#ifndef ICON_COLLECTION_H
#define ICON_COLLECTION_H

#include <list>
#include <Inventor/nodes/SoNode.h>

using namespace std;

   class ContactIconCollection3D {
   protected:
      typedef list<void*> IconList;
      unsigned int size, index_default_icon;
      SoNode **icons;
      bool IamTheOwner;
   public:
      typedef enum { NO_ERROR = 0, CANT_FIND_FILE = 1 } FILE_RESULT;
      ContactIconCollection3D():size(0),index_default_icon(1),icons(NULL),IamTheOwner(false) { 
      }
      ContactIconCollection3D(unsigned int numberOfIcons);
      void setSize(unsigned int numberOfIcons);
      unsigned int getSize() const { 
         return size; }
      SoNode* operator[](unsigned int iconNo) { 
         return icons[iconNo]; }
      void setDefaultIconTo(unsigned int index);
      SoNode* getDefaultIcon() const { 
         return index_default_icon<size ? icons[index_default_icon] : NULL; }
      FILE_RESULT load3dIconsFrom(const char* const filename, bool ownership = true);
      void dontKeepADefaultIcon();
      ~ContactIconCollection3D();
   
   };


#endif