#include "IvSwitchEngine.h"
#include <stdio.h>

   SO_ENGINE_SOURCE(IvSwitchEngine);

// Initializes the IvScaleEngine class.

   void IvSwitchEngine::initClass() {
      SO_ENGINE_INIT_CLASS(IvSwitchEngine, SoEngine, "Engine");
   }

// Constructor
   IvSwitchEngine::IvSwitchEngine() {
   // Do standard constructor tasks
      SO_ENGINE_CONSTRUCTOR(IvSwitchEngine);
   
   // Define input fields and their default values
      SO_ENGINE_ADD_INPUT(outOfRange,  (true));
      SO_ENGINE_ADD_INPUT(userVisible,  (false));
      SO_ENGINE_ADD_INPUT(intersectionCount,  (0));
      SO_ENGINE_ADD_INPUT(showIntersection,  (false));
   
   // Define the output, specifying its type
      SO_ENGINE_ADD_OUTPUT(which, SoSFInt32);
      SO_ENGINE_OUTPUT(which, SoSFInt32,setValue(SO_SWITCH_ALL));
   }


// This is the evaluation routine.
   void IvSwitchEngine::evaluate() {
     if ((userVisible.getValue())&&(!outOfRange.getValue())&&(showIntersection.getValue()||(intersectionCount.getValue()<=0)))
      SO_ENGINE_OUTPUT(which, SoSFInt32,setValue(SO_SWITCH_ALL));
     else 
      SO_ENGINE_OUTPUT(which, SoSFInt32,setValue(SO_SWITCH_NONE));
   }


// Destructor. Does nothing.
   IvSwitchEngine::~IvSwitchEngine(){  
   }
