#ifndef IVSWITCHENGINE_H
#define IVSWITCHENGINE_H

#include <Inventor/engines/SoSubEngine.h>
#include <Inventor/fields/SoSFBool.h>
#include <Inventor/fields/SoSFInt32.h>
#include <Inventor/actions/SoWriteAction.h>
#include <Inventor/nodes/SoSwitch.h>

/*!
IvSwitchEngine determines whether the head switch for and IvContactView should be on(ALL) or off(NONE)
*/
class IvSwitchEngine : public SoEngine {

   SO_ENGINE_HEADER(IvSwitchEngine);


 public:

   // Inputs:
   SoSFBool       outOfRange;
   SoSFBool       userVisible;
   SoSFInt32      intersectionCount;
   SoSFBool       showIntersection;

   /// Output: the scaled coordinate
   SoEngineOutput  which;  // (SoSFInt32)

   // Initialization
   static void initClass();

   // Constructor
   IvSwitchEngine();

 private:
   // Destructor
   virtual ~IvSwitchEngine();

   // Evaluation method
   virtual void evaluate();
};


#endif
