// generated by Fast Light User Interface Designer (fluid) version 1.0009

#ifndef bezel_h
#define bezel_h
#include <FL/Fl.H>
#include <FL/Fl_Window.H>
#include <FL/Fl_Double_Window.H> 
#include <FL/Fl_Button.H>
#include <FL/Fl_Box.H>
#include <FL/Fl_Menu_Button.H>
#include <FL/Fl_Return_Button.H>
#include <FL/Fl_Check_Button.H>
#include <FL/Fl_Output.H>
#include <FL/Fl_Input.H>
#include <FL/Fl_Widget.H>



#include <FL/Fl_Slider.H>
extern void callback(Fl_Slider*, void*);
#include <FL/Fl_Value_Slider.H>
extern void callback(Fl_Value_Slider*, void*);
#include <FL/Fl_Adjuster.H>
extern void callback(Fl_Adjuster*, void*);
#include <FL/Fl_Counter.H>
extern void callback(Fl_Counter*, void*);
#include <FL/Fl_Dial.H>
extern void callback(Fl_Dial*, void*);
#include <FL/Fl_Roller.H>
extern void callback(Fl_Roller*, void*);
#include <FL/Fl_Value_Input.H>
extern void callback(Fl_Value_Input*, void*);
#include <FL/Fl_Value_Output.H>
extern void callback(Fl_Value_Output*, void*);
#include <FL/Fl_Scrollbar.H>
extern void callback(Fl_Scrollbar*, void*);




#include "up.xpm"
#include "down.xpm"
#include "updown.xpm"
#include "ta.xpm"
#include "sphere.xpm"
#include "torp.xpm"
#include "taloss.xpm"
#include "uuv.xpm"
#include "tomahawk.xpm"
#include "dolphins.xpm"

// menu of items to be used in the drop down button menu on top of the bezel
extern Fl_Menu_Item menu_Map[];
extern Fl_Menu_Item menu_Views[];
extern Fl_Menu_Item menu_Sim[];
extern Fl_Menu_Item menu_Manipulators[];
extern Fl_Menu_Item menu_Help[];

/* Following is veriables used to hold the fields used in the right bezel*/
struct right_ui{
	Fl_Double_Window *rightWin;
	Fl_Group * sensor_group;	// group of weapon datas

	// These are group of diplay boxes for TA, SA, TRP, MIS, UUV weapon data as well as the target range data.
	Fl_Group * ta_group, *sa_group, *trp_group, *mis_group, *uuv_group, *limit_group;

	/* These are menus that contain target, target solution, TRP weapon, MIS weapon,
	   UUV weapon, TA weapon, SA weapon names and datas*/
	Fl_Menu_Button *targetMenu, *solutionMenu, *wnpMenu, *misMenu, *uuvMenu, *taMenu, *saMenu;

	/* These are variables that holds the icons to display in the right bezel*/
	Fl_Box *senno, *ucontact_icon, *dcontact_icon, *udcontact_icon, *ta_pixmap,*mapBox;

 	/* These variables are to hold the ownship data to be displayed in the right bezel*/
	Fl_Output *ownshipCourse, *ownshipSpeed, *ownshipDepth, *ownshipSet, *ownshipDrift,
		 *ownshipLAT, *ownshipLON, *ownshipTime;

	/* These variables are to hold the target data to be displayed in the right bezel*/
	Fl_Output *targetAge, *targetBearing, *targetMaxBearing, *targetMinBearing, *targetRange,
		 *targetMaxRange, *targetMinRange, *targetCourse, *targetSpeed, *targetDepth,
		 *targetMaxDepth, *targetMinDepth, *targetLAT, *targetLON;

	/* These variables are to hold the TRP weapon data to be displayed in the right bezel*/
	Fl_Output *weaponAge, *weaponBearing, *weaponRange, *weaponCourse, *weaponSpeed,
		 *weaponDepth, *weaponLAT, *weaponLON, *weaponMode;

	/* These variables are to hold the TA weapon data to be displayed in the right bezel*/
	Fl_Output *taAge, *taCB, *taCRB, *taCRR,*taCRS, *taSPD, *taDP, *taLAT, *taLON;

	/* These variables are to hold the SA weapon data to be displayed in the right bezel*/
	Fl_Output *saAge, *saSB, *saRNG, *saSR1, *saSR2;

	/* These variables are to hold the MIS weapon data to be displayed in the right bezel*/
	Fl_Output *misAge, *misBearing, *misRange, *misCourse, *misSpeed, *misDepth, *misLAT, *misLON, *misMode;

	/* These variables are to hold the UUV weapon data to be displayed in the right bezel*/
	Fl_Output *uuvAge, *uuvBearing, *uuvRange, *uuvCourse, *uuvSpeed, *uuvDepth, *uuvLAT, *uuvLON, *uuvMode;

	/* These variables are to hold the text label data to be displayed with the topdown display map*/
	Fl_Output *text1, *text2, *text3, *text4;
};

extern struct right_ui uiRight;



char WeaponCodes[][20]={"      GO",
               		"     NO_GO",
               		"     LAUNCH",
               		"RUN_TO_ENABLE",
               		"BBCM_LOCALIZE",
               		" BBCM_SEARCH",
               		"CLOSE_IN_SEARCH",
               		" COVER_SEARCH",
               		"DIRECTED_SEARCH",
               		"  INVESTIGATE",
               		"TERMINAL_HOMING",
               		"   PURSUIT",
               		"REACQUIRE_SEARCH",
               		"  REATTACK",
               		"UNDIRECTED_SEARCH",
               		"FENCE_DEPLOYMENT"
             		};




#endif
