#include "ContactEvent.h"


unsigned int ContactEvent::packTo(char *buffer) const {
   int len = name.size();
   // length of string
   *((int*)buffer) = len;
   // contact name
   memcpy(buffer+sizeof(int),name.c_str(),len);
   //solution name
   int len2 = solution.size();
   memcpy(buffer+sizeof(int)+len,&len2,sizeof(int));
   memcpy(buffer+sizeof(int)+len+sizeof(int),solution.c_str(),len2);   
   // contact type
   memcpy(buffer+sizeof(int)+len+sizeof(int)+len2,&contactType,sizeof(contactType));
   // icon ID
   memcpy(buffer+sizeof(int)+len+sizeof(int)+len2+sizeof(contactType),&iconID,sizeof(iconID));
   // position + time + everything else, as one chunk of memory
   memcpy(buffer+sizeof(int)+len+sizeof(int)+len2+sizeof(contactType)+sizeof(int),&coord,sizeof(coord));
   //threat
   memcpy(buffer+sizeof(int)+len+sizeof(int)+len2+sizeof(contactType)+sizeof(int)+sizeof(coord),&threat,sizeof(threat));
   //category
   memcpy(buffer+sizeof(int)+len+sizeof(int)+len2+sizeof(contactType)+sizeof(int)+sizeof(coord)+sizeof(threat),&category,sizeof(category));
   return sizeof(int)+len+sizeof(int)+len2+sizeof(contactType)+sizeof(iconID)+sizeof(coord)+sizeof(threat)+sizeof(category);
}

void ContactEvent::unpackFrom(const char* data) {
   // contact name length
   int len = *(int*)data;
   // get contact name
   name.assign(data+sizeof(int),len);
   // get solution name
   int len2;
   memcpy(&len2,data+sizeof(int)+len,sizeof(int));
   solution.assign(data+sizeof(int)+len+sizeof(int),len2);
   // get contact type
   memcpy(&contactType,data+sizeof(int)+len+sizeof(int)+len2,sizeof(contactType));
   // get icon ID
   memcpy(&iconID,data+sizeof(int)+len+sizeof(int)+len2+sizeof(contactType),sizeof(iconID));
   // get position + time + everything else as one mem block
   memcpy(&coord,data+sizeof(int)+len+sizeof(int)+len2+sizeof(contactType)+sizeof(iconID),sizeof(coord));
   //threat
   memcpy(&threat,data+sizeof(int)+len+sizeof(int)+len2+sizeof(contactType)+sizeof(iconID)+sizeof(coord),sizeof(threat));
   memcpy(&category,data+sizeof(int)+len+sizeof(int)+len2+sizeof(contactType)+sizeof(iconID)+sizeof(coord)+sizeof(threat),sizeof(category));
   
}

