#ifndef DIVHUD_H
#define DIVHUD_H

#include "IvHUD.h"
#include <navmgr/NavManager.h>

/* This class extends IvHUD to check if the angle between the vector 
   from the Diverse camera to the object position, and the camera aim vector
   is > than 90 degrees. If so, it doesn't draw the HUD object. This is important 
   because otherwise the HUD object would be drawn when facing 180 degrees away, from the objects */
class DiverseHUD: public IvHUD {
   SO_NODE_HEADER(DiverseHUD);
protected:
   mutable bool headDataIsOld;
   mutable dVec3 headPos,headOrientationVector;
   virtual void GLRender(SoGLRenderAction *action);
   virtual ~DiverseHUD() { }
public:
   static void initClass();
   DiverseHUD(SbViewportRegion* vp = NULL);
   /// Constructor that takes approximate number of children as argument.
   DiverseHUD(int numChildren, SbViewportRegion* vp = NULL);
   bool isWorldCoordCulled(float worldPointXcoord, float worldPointYcoord, float worldPointZcoord) const;
   bool isLocalCoordCulled(float localPointXcoord, float localPointYcoord, float localPointZcoord) const;
};

#endif
