#ifndef _NAME_TO_TRACK_MAPPING_H
#define _NAME_TO_TRACK_MAPPING_H

#include "track.h"
#include "coord.h"
#include <map>

   using namespace std;

/*! NameToTrackMapping create ObservableTrack and keeps an association between an ObservableTrack and its name */
   class NameToTrackMapping {
      typedef map<string, ObservableTrack*> MapType;
      MapType dict;
   public:
   /// returns the ObservableTrack with the given name, or NULL if it doesn't exist
      ObservableTrack *findTrackForContact(const string& trackName, const string & solutionName) const;
      ObservableTrack *findTrackForContact(const string& trackName) const;
   /// Creates an ObservableTrack with the given name
      ObservableTrack *addTrackForContact(const string& trackName, const string & solutionName, const ContactType contactType);
   /// Replaces the track currently mapped under the this name for another track
      void replaceExistingTrackForContact(const string& trackName, const string & solutionName, ObservableTrack* anotherTrack);
   /// Removes the track from the mapping WITHOUT destroying it
      void removeTrackForContact(const string& trackName, const string & solutionName);
   //makes the scale of a track and its contactview and its trackview now (x,y,z)
      void applyScaleToTracks(float x, float y, float z);
      void makeTracksVisible(int num, char solutions[][64]);
      void makeTracksGrow(int num, char solutions[][64]);
      void makeTracksReduce(int num, char solutions[][64]);
   };

#endif /*_NAME_TO_TRACK_MAPPING_H*/
