#ifndef xparser_h
#define xparser_h

#include "xwandactions.h"


struct XWandData
{
XWandButtonActions*   buttons;
unsigned int numButtons;
char** app;
int    numArgs;
int    numActions;
char*  display;

protected:
  ///Parse the file and get xwand settings
  bool xWandParser(const char* filename); 
  void allocButtons(int numButtons);
  //Parse button/action assignments
  void assignButtons(char *textLine);         
  char* nextToken(char *posInTextLine);
  // Parse arguments to program to start with button click (optional)
  void getAppArgs(char* textline);
public:
   bool readXWandConfigFile(const char* filename, const bool verbose=false);
   void printXWandDataTo(FILE *output);
 XWandData():buttons(NULL),app(NULL),numArgs(0),numActions(0),display(NULL) { }; 
~XWandData();
};


#endif

