#include "BoundedQueue.h"
#include <stddef.h>

   void BoundedQueue::resizeTo(unsigned int howManyItems) {
      unsigned int no_bytes=howManyItems*itemSize;
      if(items != NULL) {
         ptrdiff_t head_offset = head-items;
         items = (char*)realloc(items,no_bytes);
         limit = items+no_bytes;
         head = items+head_offset;
         if(count == 0) {
           tail=head;
         } else if(howManyItems > capacity) {
              if(tail <= head) {
                 unsigned int new_space = no_bytes-capacity*itemSize;
                 memmove(head+new_space,head,new_space); 
                 head+=new_space;
              } 
              else {
                 tail=items+(tail-items);
              }
         } else if(howManyItems < capacity) {
              tail = head = items;
           	  count=0;
         }
      } 
      else {
         items = (char*)malloc(no_bytes);
         limit = items+no_bytes;
         head = tail = items;
      	count = 0;
      }
      capacity = howManyItems;
   }

   bool BoundedQueue::removeStraightFromBuffer(unsigned int abs_pos, void* removedItem) {
      bool removed=false;
      char* item = items+abs_pos*itemSize;
      memcpy(removedItem,item,itemSize);	
      if(item < head) {
         if(item < tail) {
            memmove(item,item+itemSize,tail-items);
            prev(tail);
            removed=true;
         }
      } 
      else {
         memmove(head+itemSize,head,item-head); 
         next(head);
         removed=true;
      }
      count--; 
      return removed;
   }	

