#ifndef COMPASS_H
#define COMPASS_H


// 2002, NUWC Rhode Island //


#include <Inventor/nodes/SoGroup.h>
#include <Inventor/nodes/SoCamera.h>
#include <Inventor/nodes/SoCoordinate3.h>
#include <Inventor/nodes/SoBaseColor.h>
#include <Inventor/nodes/SoIndexedTriangleStripSet.h>
#include <Inventor/fields/SoSFRotation.h>

// next header is used to make IvCompass a "nice" inventor subclass
#include <Inventor/nodes/SoSubNode.h>

class SoGLRenderAction;

/*! A Compass is an Inventor object to keep the user informed what direction the scene is in.  It has a fixed screen position */
   class IvCompass: public SoNode {
      SO_NODE_HEADER(IvCompass);
   /// origin of color scale
      float origin[2];
   /// size of the color scale
      float width,height;
//      SoCamera *camera;
      void init();
   protected:
      virtual void GLRender(SoGLRenderAction* action);
      ~IvCompass();
   public:
      SoSFRotation rotation;
      static void initClass();
      IvCompass();
      void setLength(float aWidth) { 
         width=aWidth; }
      void setHeight(float aHeight) { 
         height=aHeight; }
      void setSize(float width,float height);
      void setPosition(float xleft, float ybottom) { 
         origin[0]=xleft; origin[1]=ybottom; }
//      void setCamera(SoCamera *cam) { 
//         camera=cam; }
   };

#endif
