#include "UiMediator.h"


UiMediator::UiMediator():actionFlag(BezelCommand::NONE),command(BezelCommand::NONE),selectedWeapon(BAD_OID),selectedTarget(BAD_OID) {
      memset(image,0xFF,MAP_IMAGE_SIZE);
   }


   void UiMediator::updateMap(const unsigned char* newMap) {
      memcpy(image,newMap,MAP_IMAGE_SIZE);
      actionFlag |= BezelCommand::MAP_IMAGE_UPDATED;
   }

   void UiMediator::signalContactDataAvailable(const BezelCommand::ActionFlag flag) {
      actionFlag &= ~BezelCommand::CONTACT_DATA_AVAILABLE;
      actionFlag |=flag;
   }

   void UiMediator::signalContactDataWasRead() {
      actionFlag &= ~BezelCommand::CONTACT_DATA_AVAILABLE;
   }

   void UiMediator::setArgumentForCameraCommand(unsigned int view, OID::Type whereToCenterCamera) {
      commandArg.whereToPositionCamera = view;
      commandArg.contactID = whereToCenterCamera;
   }

   void UiMediator::askMainApp(MainAppCommand::CommandFlag aCommand, OID::Type arg) {
      command = aCommand;
      commandArg.contactID = arg;
   }

   void UiMediator::askBezel(BezelCommand::ActionFlag anAction, OID::Type arg) {
      actionFlag = anAction;
      actionData.contactID = arg;
   }
