/*
DIVERSE version 3.0 Beta2
released: Friday July 25th 
The DIVERSE HOMPAGE is at: diverse.sourceforge.net

Copyright (C) 2000 - 2003  Daniel Larimer, Andrew A. Ray, Patrick Shinpaugh
			   John Kelso, and Ron Kriz

This is free software; you can redistribute it and/or modify it under
the terms of the GNU General Public License (GPL) as published by the
Free Software Foundation; either version 2 of the License, or (at your
option) any later version.

This software is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public License
along with this software, in the top level source directory in a file
named "COPYING.GPL"; if not, see it at:
http://www.gnu.org/copyleft/gpl.html or write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
USA.
**************************************************************************/
//=============================================================================
// helix.cpp
// - This class demonstraits how to build a simple DGL application with
// animation.  
//
// Created 5/14/03 By Daniel Larimer, modified by Andrew A. Ray
//=============================================================================


#include <Inventor/actions/SoGLRenderAction.h>
#include <Inventor/nodes/SoSeparator.h>
#include <Inventor/SoInput.h>

#include <navmgr/NavManager.h>
#include <dmath/dMatrix.h>
#include <displaymgr/DWindow.h>
#include <displaymgr/DDisplay.h>
#include <displaymgr/DisplayManager.h>
#include <stdio.h>

#include<eventmgr/devents.h>
#include<dgl/libdgl/cdgl.h>
//#include<qapplication.h>
//#include<qtutil/caveDeviceSimulator/caveDeviceSimulatorDialog.h>
//#include<qmainwindow.h>
//#include<msgmgr/MessageManager.h>
#include<iostream>
#include<tracer/Tracer.h>
//#include<shmmgr/ShMem.h>
//#include<shmmgr/ShmManager.h>
#ifdef WIN32
#include <windows.h>
#define _USE_MATH_DEFINES
#endif /* WIN32 */

#ifndef __APPLE__
#include <GL/gl.h>
#else
#include <OpenGL/gl.h>
#endif

#include<math.h>
#ifdef WIN32
#ifndef M_PI
#define M_PI 3.14159265358979323846
#endif /* !M_PI */
#endif /* WIN32 */
using namespace std;

#define DELTA_THETA 0.174532292f
#define DELTA_HEIGHT 0.008
#define R1 0.15f
#define R2 0.2f
#define NUM_TURNS 4
#define REVS_PER_MINUTE 15.f

float data[4];

SoSeparator* xxxroot;

void draw()
{
    glClearColor(0.f, 0.f, 0.f, 0.f);
    glEnable(GL_DEPTH_TEST);
     glEnable(GL_NORMALIZE);  
      glMatrixMode(GL_MODELVIEW);
      glPushMatrix();
      glRotatef(90.0f,1.0f,0.0f,0.0f);     
      GLint vp[4];
      glGetIntegerv(GL_VIEWPORT, vp);
      SbViewportRegion viewport;
      viewport.setWindowSize(vp[2], vp[3]);
      SoGLRenderAction renderer(viewport);
      renderer.apply(xxxroot);
      glMatrixMode(GL_MODELVIEW);
      glPopMatrix();
}


bool KeyEvent(DKeyEvent* DEvent)
{
	return false;
}
bool MouseEvent(DMouseEvent* DEvent)
{
	return false;
}
bool WandEvent(DWandEvent* DEvent)
{
	return false;
}
bool TrackerEvent(DTrackerEvent* DEvent)
{
	return false;
}

    // this function is used mainly during debugging
    void printCurrentHeadPosition() {                     
        printf("------------------------ CURRENT HEAD TRACKER -------------------------\n");
        dVec3 vec3;
	dMatrix navmatrix=  NavManager::getMatrix();
	vec3=navmatrix.getTrans();
        printf("Current Position: XYZ=[%f,%f,%f],", vec3[0],vec3[1],vec3[2]);
        DTrackerEvent *evt=EventManager::getTrackerState("headtracker");
        vec3=evt->getDirection();                     
        printf(" HPR=[%f,%f,%f]\n",vec3[0],vec3[1],vec3[2]);
        printf("-----------------------------------------------------------------------\n");
        fflush(stdout);
    }


   void setWindowSize(unsigned int left, unsigned int bottom, unsigned int width, unsigned int height) {
       vector<DDisplay*> dglDisplays = DisplayManager::getDisplays();
       vector<DWindow*> dglWindows = dglDisplays[0]->getWindows();
       dglWindows[0]->setWindowGeometry(Rect(left,bottom,width,height));
   }


int main( int argc, char** argv )
{
    SoDB::init();
    dglInit(argc, argv);
    dglDisplayCallback( draw );
    dglWandCallback(WandEvent);
    dglMouseCallback(MouseEvent);
    dglKeyCallback(KeyEvent);
    dglTrackerCallback(TrackerEvent);


    SoInput xxxloader;
    xxxloader.openFile("cube.iv");
    xxxroot = SoDB::readAll(&xxxloader);
    xxxroot->ref();
    xxxloader.closeFile();

    dglStart();
    setWindowSize(0,100,1000,800);

    while (dglIsRunning())
	    {
	        //Use the sync in case you need it
		dglSync();
		dglFrame();
	    }
}
