#include <pexpr/POMessage.h>
#include <tracer/Tracer.h>
#ifdef WIN32

#else
#include <unistd.h>
#endif
#include <dreg/Registry.h>
#include <qtutil/POMonitor.h>
#include <iostream>
#include <pluginmgr/PluginManager.h>
#include <servicemgr/GServiceManager.h>
#include <servicemgr/GService.h>
#include <services/CollabServer/cserverservice.h>
#include <msgmgr/MessageManager.h>
#include <dcollab/core/serveravatarmhandler.h>
#include <dcollab/core/cdefines.h>
#include <dcollab/core/communicator.h>
using namespace std;

int main(int argc, char** argv)
{
	//Init the registry to have the desired values
	Registry::init();
	Registry::setValue("/DIVERSE/MessageManager/POName", SERVERNAME);
	//Init the message manager
	MessageManager::init();

	//Init the service manager
	GServiceManager::init();
	//Load the 2 services we need to make the server work
	PluginManager::init();
	PluginManager::setupRegistry();
	PluginManager::loadPlugin("QtService");
	PluginManager::loadPlugin("CServerService");
	//Create an avatar handler
	ServerAvatarHandler MyHandler;
	//Get the actual service we want out
	GService* TService = GServiceManager::getService("CServerService");
	CServerService* MyServ = (CServerService*) TService;
	MyServ->getCom()->startListen(COLLABSERVERPORT);
	//Add the message handlers to the server
	MyServ->addMHandler(&MyHandler);
	//Start the services
	GServiceManager::startService("QtService");
	GServiceManager::startService("CServerService");
	if (argc > 1)
	{
		POMonitor* Mon = new POMonitor(NULL);
		Mon->show();
	}
	GServiceManager::start();
	while (GServiceManager::isRunning())
	{
		GServiceManager::frame();
#ifdef WIN32
		Sleep(10);
#else
		usleep(10000);
#endif
	}
}
