#ifndef WIN32
#include<unistd.h>
#endif
#include<revent/REventClient.h>
#include<dutil/CommandArgs.h>
#include<servicemgr/GServiceManager.h>
#include<qapplication.h>

int main( int argc, char** argv )
{
    QApplication app(argc, argv, false);
    CommandArgs::init(argc, argv);
    EventManager::init();
    GServiceManager::init();
    REventClient* ec = REventClient::instance();

    if( argc < 3 )
    {
        cout<<"Usage: ./deventmgr [import|export] [hostname] [eventtype]"
            <<"[yes|no] [Other Options]\n";
        cout<<"Other Options: \n";
        CommandArgs::printUsage();
        return -1;
    }
    string cmd  = string(argv[1]);
    string host = string(argv[2]);
    string type = string(argv[3]);
    bool   state = string(argv[4]) == "yes";
    if( cmd == "import" )
        ec->importRemoteEvents( type, host, state );
    else if ( cmd == "export" )
        ec->exportRemoteEvents( type, host, state );
    else
    {
        cout<<"Unknown command: "<<cmd<<endl;
        cout<<"Usage: ./deventmgr [import|export] [hostname] [eventtype]"
            <<"[yes|no] [Other Options]\n";
        cout<<"Other Options: \n";
        CommandArgs::printUsage();
    }

    // Give the message time to get out the socket
    app.processEvents();
#ifdef WIN32
    Sleep( 10 );
#else
    usleep( 10000 );
#endif
    app.processEvents();
    return 0;
}
