#include "DisplayConfigDialog.h"
#include "DisplayConfigWidget.h"
#include <qmenubar.h>
#include <qlayout.h>

DisplayConfigDialog::DisplayConfigDialog()
{
    m_widget = new DisplayConfigWidget( this );
    QMenuBar* menu = new QMenuBar( this );
    QPopupMenu* file = new QPopupMenu( this );
    file->insertItem( "&New", m_widget, SLOT( newDisplay() ), CTRL+Key_N );
    file->insertItem( "&Open...", m_widget, SLOT( openDisplay() ), CTRL+Key_O );
    file->insertItem( "&Save", m_widget, SLOT( saveDisplay() ), CTRL+Key_S );
    file->insertItem( "Save As...", m_widget, SLOT( saveAsDisplay() ) );
    file->insertItem( "&Close Display", m_widget, SLOT( closeDisplay() ), CTRL+Key_W );
    file->insertItem( "Close All Displays", m_widget, SLOT( closeAllDisplays() ) );
    file->insertItem( "&Quit", this, SLOT( quit() ), CTRL+Key_Q );
    menu->insertItem( "&File", file );

    QVBoxLayout* layout = new QVBoxLayout( this );
    layout->addWidget( menu );
    layout->addWidget( m_widget );
}

void DisplayConfigDialog::quit()
{
    close();
}
