#ifndef _DISPLAYCONFIGWIDGET_H_
#define _DISPLAYCONFIGWIDGET_H_
#include <qwidget.h>

class DisplayConfigTree;
class DisplayWidget;
class WindowWidget;
class ViewportWidget;
class QString;
class QWidgetStack;
class QListViewItem;
class QPopupMenu;

class DisplayConfigWidget : public QWidget
{
    Q_OBJECT
    public:
        DisplayConfigWidget( QWidget* parent );
        bool init();
        QWidgetStack* getMainWidgetStack() { return m_mainwidgetstack; };

    signals:

    public slots:
        void newDisplay();
        void openDisplay();
        void saveDisplay();
        void saveAsDisplay();
        void closeDisplay();
        void closeAllDisplays();
		void newWindow();
		void removeWindow();
		void newViewport();
		void removeViewport();
        void updateSelection( QListViewItem* item );
		void itemContextMenu( QListViewItem* item, const QPoint& point, int column );

    private:
        DisplayConfigTree* m_tree;
        QWidgetStack* m_mainwidgetstack;
		DisplayWidget* m_displaywidget;
		WindowWidget* m_windowwidget;
		ViewportWidget* m_viewportwidget;
		QPopupMenu* m_rootmenu;
		QPopupMenu* m_displaymenu;
		QPopupMenu* m_windowmenu;
		QPopupMenu* m_viewportmenu;
};

#endif
