#ifndef _DISPLAYWIDGET_H_
#define _DISPLAYWIDGET_H_
#include <qwidget.h>

class DisplayConfigTree;
class DisplayData;
class QLineEdit;
class QCheckBox;
class QString;

class DisplayWidget : public QWidget
{
	Q_OBJECT
	public:
		DisplayWidget( QWidget* parent, int stackorder, DisplayConfigTree* tree );

		void update( DisplayData* display );

	public slots:
		void nameChanged( const QString& name );
		void threadedToggled( bool threaded );

	private:
		QWidget* m_parent;
		int m_stackorder;
		DisplayConfigTree* m_tree;
		DisplayData* m_display;
		QLineEdit* m_name;
		QCheckBox* m_threaded;
};

#endif
