#ifndef _VIEWPORTWIDGET_H_
#define _VIEWPORTWIDGET_H_
#include <qwidget.h>

class DisplayConfigTree;
class ViewportData;
class QLineEdit;
class QComboBox;
class QWidgetStack;

class ViewportWidget : public QWidget
{
	Q_OBJECT
	public:
		ViewportWidget( QWidget* parent, int stackorder, DisplayConfigTree* tree );

		void update( ViewportData* viewport );

	public slots:
		void nameChanged( const QString& name );
		void sizeleftChanged( const QString& left );
		void sizebottomChanged( const QString& bottom );
		void sizewidthChanged( const QString& width );
		void sizeheightChanged( const QString& height );
		void trackernameChanged( const QString& trackername );
		void projectiontypeChanged( int projectiontype );
		void eyeChanged( int eye );
		void screenNameChanged( const QString& screenname );
		void centerxChanged( const QString& centerx );
		void centeryChanged( const QString& centery );
		void centerzChanged( const QString& centerz );
		void headingChanged( const QString& heading );
		void pitchChanged( const QString& pitch );
		void rollChanged( const QString& roll );
		void widthChanged( const QString& width );
		void heightChanged( const QString& heaight );
		void depthChanged( const QString& depth );
		void fovxChanged( const QString& fovx );
		void fovyChanged( const QString& fovy );

	private:
		QWidget* m_parent;
		int m_stackorder;
		DisplayConfigTree* m_tree;
		ViewportData* m_viewport;
		QLineEdit* m_name;
		QLineEdit* m_sizeleft;
		QLineEdit* m_sizebottom;
		QLineEdit* m_sizewidth;
		QLineEdit* m_sizeheight;
		QLineEdit* m_trackername;
		QComboBox* m_projectiontype;
		QComboBox* m_eye;
        QWidgetStack* m_projectionwidgetstack;
		QWidget* m_screenwidget;
		QWidget* m_perspectivewidget;
		QLineEdit* m_screenname;
		QLineEdit* m_centerx;
		QLineEdit* m_centery;
		QLineEdit* m_centerz;
		QLineEdit* m_heading;
		QLineEdit* m_pitch;
		QLineEdit* m_roll;
		QLineEdit* m_width;
		QLineEdit* m_height;
		QLineEdit* m_depth;
		QLineEdit* m_fovx;
		QLineEdit* m_fovy;
};

#endif
