#ifndef _WINDOWWIDGET_H_
#define _WINDOWWIDGET_H_
#include <qwidget.h>

class DisplayConfigTree;
class WindowData;
class QLineEdit;
class QCheckBox;
class QComboBox;

class WindowWidget : public QWidget
{
	Q_OBJECT
	public:
		WindowWidget( QWidget* parent, int stackorder, DisplayConfigTree* tree );

		void update( WindowData* window );

	public slots:
		void nameChanged( const QString& name );
		void sizeleftChanged( const QString& left );
		void sizebottomChanged( const QString& bottom );
		void sizewidthChanged( const QString& width );
		void sizeheightChanged( const QString& height );
		void xscreenChanged( const QString& xscreen );
		void quadbufferChanged( bool quadbuffer );
		void borderChanged( bool border );
		void fullScreenChanged( bool fullscreen );
		void sharedContextWindowChanged( const QString& sharedcontextwindow );

	private:
		QWidget* m_parent;
		int m_stackorder;
		DisplayConfigTree* m_tree;
		WindowData* m_window;
		QLineEdit* m_name;
		QLineEdit* m_sizeleft;
		QLineEdit* m_sizebottom;
		QLineEdit* m_sizewidth;
		QLineEdit* m_sizeheight;
		QLineEdit* m_xscreen;
		QCheckBox* m_quadbuffer;
		QCheckBox* m_border;
		QCheckBox* m_fullscreen;
		QComboBox* m_sharedcontextwindow;
};

#endif
