#include<qtutil/QServiceManager.h>
#include<tracer/Tracer.h>
#include<diverse.h>
#include<dreg/Registry.h>
#include<pexpr/POTextMsg.h>
#ifdef WIN32
#include <qapplication.h>
#endif

//===============================================================
// diversed is the daemon that runs the various servers used by 
// DIVERSE such as Shared Memory, Remote Events, and Collab Tools.
//
// This server consists of a GServiceManager running the following
//  services:
//      QtService - Pony Express, Message Manager, Commune Server depend on this
//      EventService - To handle internal events from the IS900
//      EventServer - Handles remote events
//      IS900  - Reads the serial port and generates events
//      CollabServer - runs the collab server
//      Sleeper Service - prevents the daemon from hoging CPU
//
// The following plugins are loaded:
//      CommuneServerPlugin - Loads the shared memory server
//================================================================

int main( int argc, char** argv )
{
//    RegisterMessage<POTextMsg> msg;
    POTextMsg test;
    // Override the default registry name
    Registry::init( "diversed.xml" );
    // Override the default services and navigations
    Registry::getValue("/DIVERSE/DisplayManager/NoDisplays", "true", "false or true" );
    Registry::getValue( "/DIVERSE/NavManager/navigations/MouseNav", 
                        "no" );
    // Load the commune server plugin
    Registry::getValue( "/DIVERSE/PluginManager/plugins/CommuneServer",
                        "yes" );

    // Load the event server service
    Registry::getValue( "/DIVERSE/PluginManager/plugins/EventServer", 
                        "yes" );
#ifdef WIN32
	QApplication qApp( argc, argv );
#endif /* WIN32 */
    DiverseApp app( argc, argv );
    QServiceManager::init();
    app.run();
    return 0;
}
