//=============================================================================
// Creates the shared memory daemon/server 
//=============================================================================
#include<iostream>
#include<shmmgr/ShMem.h>
#include<shmmgr/ShmManager.h>
#ifndef WIN32
#include<unistd.h>
#endif
#include<dreg/Registry.h>
#include<tracer/Tracer.h>
#include<qapplication.h>

using namespace std;

int main( int argc, char** argv )
{
    if( argc < 5 )
    {
        cerr<<"Usage: ./dmapshm remotehost port remotesegment localsegment\n";
        return 1;
    }
    QApplication* app = new QApplication( argc, argv, false );
    Tracer::init();
    ShmManager::init();
    Tracer::printStatus( 5 );
    if( 0 == ShmManager::mapSegment( argv[1], atoi(argv[2]), 
                                     argv[3], argv[4] ) )
    {
        Tracer::stat( "Segment \"%s\" on host %s:%s successfully mapped \n"
                      "\t\tto local segment %s.", 
                      argv[3], argv[1], argv[2], argv[4] );
    }else
    {
        Tracer::error( "Segment \"%s\" on host %s:%s couldn't be mapped \n"
                      "\t\tto local segment %s.", 
                      argv[3], argv[1], argv[2], argv[4] );
    }
    app->processEvents();
}
