#include <Inventor/actions/SoGetMatrixAction.h>
#include <Inventor/actions/SoSearchAction.h>
#include <Inventor/SoDB.h>
#include <Inventor/SoInteraction.h>
#include <Inventor/SoSceneManager.h>
#include <Inventor/nodekits/SoNodeKit.h>
#include <Inventor/nodes/SoCylinder.h>
#include <Inventor/nodes/SoDirectionalLight.h>
#include <Inventor/nodes/SoDrawStyle.h>
#include <Inventor/nodes/SoSeparator.h>
#include <Inventor/nodes/SoMaterial.h>
#include <Inventor/nodes/SoPerspectiveCamera.h>
#include <Inventor/nodes/SoRotor.h>
#include <Inventor/nodes/SoShuttle.h>
#include <Inventor/nodes/SoSphere.h>
#include <Inventor/nodes/SoTransform.h>
#include <Inventor/fields/SoSFVec3f.h>
#include <Inventor/SbLinear.h>
#include <Inventor/nodes/SoTransformSeparator.h>
#include <Inventor/nodes/SoMatrixTransform.h>

#include <dgl/libdgl/cdgl.h>
#include <dgl/dcoin/dcoin.h>
#include <GL/gl.h>
#include <GL/glu.h>

// ----------------------------------------------------------------------
// 

int main(int argc, char** argv)
{
	if (argc !=2)
	{
		cout << "Invalid usage of " << argv[0] << endl;
		cout << "Usage:  " << argv[0] << " filetoload\n";
		return -1;
	}
	//DCoin::getSceneManager()->setBackgroundColor(SbColor(0.2f, 0.2f,  0.2f));
	dglInit(argc, argv);
	DCoin::init();
	SoSeparator* Temp = DCoin::loadFile(argv[1]);
	if (Temp == NULL)
	{
		cout << "Could not load file\n";
		return 0;
	}
	DCoin::getWorld()->addChild(Temp);
	dglRun();
}
