#include <Inventor/actions/SoGetMatrixAction.h>
#include <Inventor/actions/SoSearchAction.h>
#include <Inventor/SoDB.h>
#include <Inventor/SoInteraction.h>
#include <Inventor/SoSceneManager.h>
#include <Inventor/nodekits/SoNodeKit.h>
#include <Inventor/nodes/SoCylinder.h>
#include <Inventor/nodes/SoCube.h>
#include <Inventor/nodes/SoDirectionalLight.h>
#include <Inventor/nodes/SoDrawStyle.h>
#include <Inventor/nodes/SoSeparator.h>
#include <Inventor/nodes/SoMaterial.h>
#include <Inventor/nodes/SoPerspectiveCamera.h>
#include <Inventor/nodes/SoRotor.h>
#include <Inventor/nodes/SoShuttle.h>
#include <Inventor/nodes/SoSphere.h>
#include <Inventor/nodes/SoTransform.h>
#include <Inventor/fields/SoSFVec3f.h>
#include <Inventor/SbLinear.h>
#include <Inventor/nodes/SoTransformSeparator.h>
#include <Inventor/nodes/SoMatrixTransform.h>

#include <dgl/libdgl/cdgl.h>
#include <dmath/dMatrix.h>
#include <dmath/dQuat.h>
#include <dgl/dcoin/dcoin.h>
#include <GL/gl.h>
#include <GL/glu.h>

// ----------------------------------------------------------------------
// 

int main(int argc, char** argv)
{
	//DCoin::getSceneManager()->setBackgroundColor(SbColor(0.2f, 0.2f,  0.2f));
	dglInit(argc, argv);
	DCoin::init();

	SoSeparator* Temp = new SoSeparator;
	SoSeparator* Temp2 = new SoSeparator;

	SoTransform* Tform = new SoTransform;
	Tform->translation.setValue(6,0,0);

	SoTransform* Tform2 = new SoTransform;
	Tform2->translation.setValue(12,0,0);
	Temp2->addChild(Tform2);

	SoTransform* m_flip = new SoTransform;
	dMatrix test90;
	test90.makeIdentity();
	test90.makeRotate(DEG2RAD(-90), dVec3(1,0,0));
	dQuat rot = test90.getQuat();
	//Set the rotation and then the translation of the navigation node
	m_flip->rotation.setValue(rot.x(), rot.y(), rot.z(), rot.w());
	//Setup the world
	Temp->addChild(Tform);
	//Temp->addChild(m_flip);

	SoMaterial* material = new SoMaterial;
	material->diffuseColor.setValue(0.2f, 0.0f, 0.8f);
	Temp->addChild(material);
	Temp2->addChild(material);

	SoCube* MySquare  = new SoCube;
	MySquare->width.setValue(5);
	MySquare->height.setValue(5);
	MySquare->depth.setValue(5);
	Temp->addChild(MySquare);
	Temp2->addChild(MySquare);

	DCoin::getWorld()->addChild(Temp);
	DCoin::getWorld()->addChild(Temp2);
	dglRun();
}
