//=============================================================================
// helix.cpp
// - This class demonstraits how to build a simple DGL application with
// animation.  
//
// Created 5/14/03 By Daniel Larimer, modified by Andrew A. Ray
//=============================================================================
#include<eventmgr/devents.h>
#include<dgl/libdgl/cdgl.h>
//#include<qapplication.h>
//#include<qtutil/caveDeviceSimulator/caveDeviceSimulatorDialog.h>
//#include<qmainwindow.h>
//#include<msgmgr/MessageManager.h>
#include<iostream>
#include<tracer/Tracer.h>
//#include<shmmgr/ShMem.h>
//#include<shmmgr/ShmManager.h>
#ifdef WIN32
#include <windows.h>
#define _USE_MATH_DEFINES
#endif /* WIN32 */

#ifndef __APPLE__
#include <GL/gl.h>
#else
#include <OpenGL/gl.h>
#endif

#include<math.h>
#ifdef WIN32
#ifndef M_PI
#define M_PI 3.14159265358979323846
#endif /* !M_PI */
#endif /* WIN32 */
using namespace std;

#define DELTA_THETA 0.174532292f
#define DELTA_HEIGHT 0.008
#define R1 0.15f
#define R2 0.2f
#define NUM_TURNS 4
#define REVS_PER_MINUTE 15.f

float current_angle;
float data[4];
GLuint helix_list;

void drawHelix();

void draw()
{
    glClearColor(0.f, 0.f, 0.f, 0.f);
    glEnable(GL_DEPTH_TEST);
    glShadeModel(GL_SMOOTH);
    glEnable(GL_LIGHTING);
    glEnable(GL_LIGHT0);
    glEnable(GL_NORMALIZE);
    glEnable(GL_COLOR_MATERIAL);
    glPolygonMode(GL_FRONT_AND_BACK, GL_LINE);
    
    glEnable(GL_ALPHA_TEST);
    glAlphaFunc(GL_GREATER, 0);
    glEnable(GL_BLEND);

  float light_ambient[]   = {.3f, .3f, .3f, 1.f};
  float light_diffuse[]   = {.3f, .3f, .3f, 1.f};
  float light_direction[] = {0.f, -1.f, 1.f, 0.f};

  glLightfv(GL_LIGHT0, GL_AMBIENT, light_ambient);
  glLightfv(GL_LIGHT0, GL_DIFFUSE, light_diffuse);
  glLightfv(GL_LIGHT0, GL_POSITION, light_direction);

  
  glMatrixMode(GL_MODELVIEW);



    glPolygonMode(GL_FRONT_AND_BACK, GL_LINE);
  
  glPushMatrix();
  glScalef( .25, .25, .25 );
  glTranslatef(0.f, 1.f, 0.f);
  glRotatef(current_angle, 0.f, 0.f, 1.f); 
  drawHelix();
  glRotatef(180.f, 0.f, 0.f, 1.f);
  drawHelix();
  glPopMatrix();
}

void postconfig()
{
    glClearColor(0.f, 0.f, 0.f, 0.f);
    glEnable(GL_DEPTH_TEST);
    glShadeModel(GL_SMOOTH);
    glEnable(GL_LIGHTING);
    glEnable(GL_LIGHT0);
    glEnable(GL_NORMALIZE);
    glEnable(GL_COLOR_MATERIAL);
    glPolygonMode(GL_FRONT_AND_BACK, GL_LINE);
    
    glEnable(GL_ALPHA_TEST);
    glAlphaFunc(GL_GREATER, 0);
    glEnable(GL_BLEND);
}

void drawHelix()
{
//  helix_list = glGenLists(1);
//  glNewList(helix_list, GL_COMPILE);
  float theta, h;
  float x1, y1, x2, y2, z, td;
  int i;

  theta = 0.f;
  h = 0.5f;
  glBegin(GL_TRIANGLE_STRIP);
  for (i=0; i < NUM_TURNS * 36; i++) {
    z = h;
    x1 = R1 * sin (theta);
    y1 = R1 * cos (theta);
    x2 = R2 * sin (theta);
    y2 = R2 * cos (theta);
    td = theta * 180.f / M_PI;
    glColor3f(fabs(180.f - td) / 180.f,
	      fabs(180.f - fabs(td - 240.f)) / 180.f,
	      fabs(180.f - fabs(td - 120.f)) / 180.f);
    glVertex3f(x1, y1, z);
    glVertex3f(x2, y2, z);
    theta += DELTA_THETA;
    if (theta > 2 * M_PI)
      theta -= 2 * M_PI;
    h -= DELTA_HEIGHT;    
  }
  glEnd();
//     glEndList();

}

void update()
{
    current_angle += 1;
    if( current_angle > 360 ) current_angle -= 360;
}

void preconfig()
{
}
void preproc()
{
}
void prenavdraw()
{
	/*
    glPolygonMode(GL_FRONT, GL_FILL);
  glPushMatrix();
    glColor4f( 1., 0., 0., 0.5 );
    glBegin( GL_POLYGON );
        glVertex3f( -1.000, 1.000, -1.000 );
        glVertex3f( 1.000, 1.000, -1.000 );
        glVertex3f( 1.000, 1.000, 1.000 );
        glVertex3f( -1.000, 1.000, 1.000 );
    glEnd();
    glColor4f( 1., 0., 1., 0.5 );
    glBegin( GL_POLYGON );
        glVertex3f( -1.000, -1.000, 1.000 );
        glVertex3f( -1.000, -1.000, -1.000 );
        glVertex3f( -1.000, 1.000, -1.000 );
        glVertex3f( -1.000, 1.000, 1.000 );
    glEnd();
    glColor4f( 0., 1., 1., 0.5 );
    glBegin( GL_POLYGON );
        glVertex3f( 1.000, 1.000, 1.000 );
        glVertex3f( 1.000, 1.000, -1.000 );
        glVertex3f( 1.000, -1.000, -1.000 );
        glVertex3f( 1.000, -1.000, 1.000 );
    glEnd();
    glColor4f( 0., 1., 0., 0.5 );
    glBegin( GL_POLYGON );
        glVertex3f( -1.000, -1.000, -1.000 );
        glVertex3f( 1.000, -1.000, -1.000 );
        glVertex3f( 1.000, 1.000, -1.000 );
        glVertex3f( -1.000, 1.000, -1.000 );
    glEnd();
    glColor4f( 1., 1., 0., 0.5 );
    glBegin( GL_POLYGON );
        glVertex3f( -1.000, 1.000, 1.000 );
        glVertex3f( 1.000, 1.000, 1.000 );
        glVertex3f( 1.000, -1.000, 1.000 );
        glVertex3f( -1.000, -1.000, 1.000 );
    glEnd();
    glColor4f( 1., .5, .5, 0.5 );
    glBegin( GL_POLYGON );
        glVertex3f( -1.000, -1.000, 1.000 );
        glVertex3f( 1.000, -1.000, 1.000 );
        glVertex3f( 1.000, -1.000, -1.000 );
        glVertex3f( -1.000, -1.000, -1.000 );
    glEnd();
    
  glPopMatrix();
  */
}

bool KeyEvent(DKeyEvent* DEvent)
{
	return false;
}
bool MouseEvent(DMouseEvent* DEvent)
{
	return false;
}
bool WandEvent(DWandEvent* DEvent)
{
	return false;
}
bool TrackerEvent(DTrackerEvent* DEvent)
{
	return false;
}

int main( int argc, char** argv )
{
    current_angle = 0;
    dglInit(argc, argv);
    dglPreConfigCallback( preconfig );
    dglInitContextCallback( postconfig );
    dglDisplayCallback( draw );
    dglPreProcessCallback ( preproc);
    dglPostProcessCallback( update );
    dglPreNavDisplayCallback(prenavdraw);
    dglWandCallback(WandEvent);
    dglMouseCallback(MouseEvent);
    dglKeyCallback(KeyEvent);
    dglTrackerCallback(TrackerEvent);

    bool IWANTCONTROL=false;
    if (!IWANTCONTROL)
	    dglRun();
    else
    {
	    dglStart();
	    while (dglIsRunning())
	    {
	        //Use the sync in case you need it
		dglSync();
		dglFrame();
	    }
    }
}
