// OpenGL Fluid Object Class
// 
// Author: Stephen Manley - smanley@nyx.net
// Date: Oct 12th 1999
// 
// Description:
// 
// This class implements a flexible object of varying resolution in OpenGL.
// 
// 
//////////////////////////////////////////////////////////////////////////////////////

#ifndef FLUID
#define FLUID

#ifndef NODE
#include "Node.h"
#endif


class FluidObject
{
	public:
	
		// Constructors
		FluidObject();
		~FluidObject();

		// Actions
		void initialize();
		void draw();
		void generateSurface();
		void applyTexture();
		void applyForce(int magnitude);

		void loadMesh();
		void saveMesh();

		void enableDrawSprings();
		void disableDrawSprings();

		void displaySurface();

		// Modifiers
		void setDrawingMode(int val);

	private:
		
		int center;
		int nodeCount;
		int asSurface;
		int asPoints;

		Node* mesh[1000];

};
#endif
