/***************************************************************************
                          opacity.cpp  -  description
                             -------------------
    begin                : Fri Apr 26 2002
    copyright            : (C) 2002 by Michael Shore
    email                : mshore@sv.vt.edu
 ***************************************************************************/

#include <dgl/dvtk/DVtkRenderer.h>
#include <dgl/dvtk/DVtkRenderWindow.h>

#include <stdlib.h>
#include <signal.h>

#include "vtk/vtkSphereSource.h"
#include "vtk/vtkCubeSource.h"
#include "vtk/vtkPolyDataMapper.h"
#include "vtk/vtkTransform.h"
#include "vtk/vtkTransformFilter.h"
#include "vtk/vtkDataSetMapper.h"
#include <vtk/vtkProperty.h>


int main (int argc, char** argv)
{

/** Begin VTK Actor Code **/
	
   //Create a translucent sphere
    vtkSphereSource *spheresrc = vtkSphereSource::New();
      spheresrc->SetThetaResolution(25);
      spheresrc->SetPhiResolution(25);
   
    vtkTransform * aTransform = vtkTransform::New();
      aTransform->Translate(0.,1.0,-0.5);

    vtkTransformFilter * aTF = vtkTransformFilter::New();
      aTF->SetInput((vtkPointSet*) spheresrc->GetOutput());
      aTF->SetTransform(aTransform);
    
    vtkDataSetMapper *spheremap = vtkDataSetMapper::New();
      spheremap->SetInput((vtkDataSet *)aTF->GetOutput());

    vtkActor *sphere = vtkActor::New();
      sphere->SetMapper(spheremap);
      sphere->GetProperty()->SetColor(0.0, 0.0, 1.0);
      sphere->GetProperty()->SetOpacity(0.5);

	//Create an opaque cube
    vtkCubeSource *cubesrc = vtkCubeSource::New();
      cubesrc->SetXLength(0.65);
      cubesrc->SetYLength(0.65);
      cubesrc->SetZLength(0.65);

    vtkTransformFilter * aTF2 = vtkTransformFilter::New();
      aTF2->SetInput((vtkPointSet*) cubesrc->GetOutput());
      aTF2->SetTransform(aTransform);

    vtkDataSetMapper *cubemap = vtkDataSetMapper::New();
      cubemap->SetInput((vtkDataSet *)aTF2->GetOutput());

    vtkActor *cube = vtkActor::New();
      cube->SetMapper(cubemap);
      cube->GetProperty()->SetColor(1.0, 0.0, 0.0);
 
/** End VTK Actor Code **/

   //Create Renderer and RenderWindow
   DVtkRenderer *ren;
   DVtkRenderWindow *renwin;
   
   ren = DVtkRenderer::New(argc,argv);
   renwin = DVtkRenderWindow::New();

   //Add Renderer to RenderWindow (imitating VTK code)
   renwin -> AddRenderer(ren);

   //Add Actors to Renderer
   ren -> AddActor(sphere);
   ren -> AddActor(cube);

	//Run application
	ren -> run();

   //Cleanup
   ren->Delete();

   return 0;
}
