/***************************************************************************
                          texture.cpp  -  description
                             -------------------
    begin                : Fri Apr 26 2002
    copyright            : (C) 2002 by Michael Shore
    email                : mshore@sv.vt.edu
 ***************************************************************************/

#include <dgl/dvtk/DVtkRenderer.h>
#include <dgl/dvtk/DVtkRenderWindow.h>

#include <stdlib.h>
#include <signal.h>

#include <vtk/vtkTIFFReader.h>
#include <vtk/vtkTexture.h>
#include <vtk/vtkCubeSource.h>
#include <vtk/vtkPolyDataMapper.h>
#include <vtk/vtkActor.h>


int main (int argc, char** argv)
{

/** Begin VTK Actor Code **/
	
  vtkTIFFReader *tiff = vtkTIFFReader::New();
    tiff->SetFileName("vtk.tif");

  vtkTexture *atext = vtkTexture::New();
    atext->SetInput(tiff->GetOutput());
    atext->InterpolateOn();

  vtkCubeSource *cube = vtkCubeSource::New();

  vtkPolyDataMapper *cubeMapper = vtkPolyDataMapper::New();
    cubeMapper->SetInput(cube->GetOutput());

  vtkActor *actor = vtkActor::New();
    actor->SetMapper(cubeMapper);
    actor->SetTexture(atext);
    actor->SetPosition(0.0, 1.0, -0.5);
    actor->RotateY(180.0);
    actor->SetScale(0.5);

  vtkTIFFReader *tiff2 = vtkTIFFReader::New();
    tiff2->SetFileName("jimmy.tif");

  vtkTexture *atext2 = vtkTexture::New();
    atext2->SetInput(tiff2->GetOutput());
    atext2->InterpolateOn();

  vtkCubeSource *cube2 = vtkCubeSource::New();

  vtkPolyDataMapper *cube2Mapper = vtkPolyDataMapper::New();
    cube2Mapper->SetInput(cube2->GetOutput());

  vtkActor *actor2 = vtkActor::New();
    actor2->SetMapper(cube2Mapper);
    actor2->SetTexture(atext2);
    actor2->SetPosition(0.0, 1.15, 0.0);
    actor2->RotateY(180.0);
    actor2->RotateZ(30.0);
    actor2->SetScale(0.5);

/** End VTK Actor Code **/

   //Create Renderer and RenderWindow
   DVtkRenderer *ren;
   DVtkRenderWindow *renwin;
   
   ren = DVtkRenderer::New(argc,argv);
   renwin = DVtkRenderWindow::New();

   //Add Renderer to RenderWindow (imitating VTK code)
   renwin -> AddRenderer(ren);

   //Add Actors to Renderer
   ren -> AddActor(actor);
   ren -> AddActor(actor2);

	//Run application
	ren -> run();

   //Cleanup
   ren->Delete();

   return 0;
}
