//=============================================================================
// This is a simple and useful example of how to write a simple DOSG application
//=============================================================================
//#include<diverse.h>
#include<dosg/dosgdep.h>
#include<osgDB/Registry>
#include<tracer/Tracer.h>
using namespace std;

bool checkUsage( int argc, char** argv );

int main( int argc, char** argv )
{
    if( !checkUsage( argc, argv ) ) return 1;

    DOsgApp theApp(argc,argv);

    // Let there be light
    DOSG::getWorld()->addChild( new osg::LightSource() );
    // and there was light and it was good

/*    osgDB::Registry::instance()->loadLibrary(
        osgDB::Registry::instance()->createLibraryNameForExt("3ds") );
    osgDB::Registry::instance()->loadLibrary(
        osgDB::Registry::instance()->createLibraryNameForExt("iv") );
    osgDB::Registry::instance()->loadLibrary(
        osgDB::Registry::instance()->createLibraryNameForExt("wrl") );*/
    // From the void I say let the be a model
    if( argc > 1 )
    {
        Node* node = readNodeFile( argv[1] );
        DOSG::getWorld()->addChild( node );
    }
    // and there was a model and I saw it was good, said it was good and it was good
    theApp.run();
    return 0;
}


bool checkUsage( int argc, char** argv )
{
    if( argc > 2 )
    {
        Tracer::error( "Usage: ./dosg-fly [model_file]" );
        return false;
    }
    return true;
}
