//=============================================================================
// Creates the shared memory daemon/server 
//=============================================================================
#include<iostream>
#include<shmmgr/ShMem.h>
#include<shmmgr/ShmManager.h>
#ifndef WIN32
#include<unistd.h>
#endif /* !WIN32 */
#include<dreg/Registry.h>
#include<tracer/Tracer.h>
#include<qapplication.h>

using namespace std;

int main( int argc, char** argv )
{
    QApplication* app = new QApplication( argc, argv, false );
    Tracer::init();
    ShmManager::init();

    ShmManager::createSegment( "TestSegment", 4*sizeof(int) );
    ShMem* mem = NULL;
	int size = 0;
    while( !mem || !size )
    {
        app->processEvents();
        mem = ShmManager::getSegment( "TestSegment" );
		size = mem->size();
#ifdef WIN32
		Sleep(100);
#else
        usleep(100000);
#endif
        cout<<"waiting for valid getSegment(TestSegment)\n";
    }

    int data[4];
    for( unsigned int i = 0; true; i++ )
    {
        app->processEvents();
#ifdef WIN32
		Sleep(100);
#else
        usleep(100000);
#endif
        mem->read( (char*)&data, 0, 4*sizeof(int) );
        cout<<"data: "<<data[0]<<"\t\t"<<data[1]<<"\t\t"
                      <<data[2]<<"\t\t"<<data[3]<<endl;
    }
}
