#include"Command.h"
#include<string>

using namespace std;

//=============================================================================
/// @brief Constructor.
///
/// Takes a line, breaks it up into args based on white space.
//=============================================================================
Command::Command( const string& line )
{
    string tok;
    for( unsigned int i = 0; i < line.size(); i++ )
    {
        if( line[i] == ' ' || line[i] == '\t' || line[i] == '\n' )
        {
            if ( tok.size() ) m_args.push_back(tok);
            tok = "";
            continue;
        }
        tok += line[i];
    }
    if( tok.size() ) m_args.push_back(tok);
}

//=============================================================================
/// @brief Copy constructor.
/// @param cpy - the Command object to be copied.
//=============================================================================
Command::Command( const Command& cpy )
:m_args( cpy.m_args )
{}

//=============================================================================
/// @brief Constructor.
/// @param args - a vector containg the list of arguments.
//=============================================================================
Command::Command( const vector<string>& args )
:m_args(args)
{}

//=============================================================================
// Function Name: getLine
/// @brief Get the command as a line separated by spaces.
/// @return a string containing the command as a line separated by spaces.
//=============================================================================
string Command::getLine()const
{
    string line;
    for( unsigned int i = 0; i < m_args.size(); i++ )
    {
        line += m_args[i] + " ";
    }
    return line;
}
