#ifndef _COMMANDHANDLER_H_
#define _COMMANDHANDLER_H_
#include<commander/Command.h>
class CommandOut;

//=============================================================================
/// @class CommandHandler
/// @author Daniel Larimer
/// @brief Describes the interface to classes that can handle commands.
///
/// All classes which are going to handle commands using the Commander module
/// should derive the class from CommandHandler.
//=============================================================================
class COMMANDER_API CommandHandler
{
    public:
        virtual ~CommandHandler(){};
        virtual CommandOut* execute( const Command& cmd ) = 0;
};

#endif
