#include <string>
#include<stdio.h>
#include<stdarg.h>
#include<iostream>
using namespace std;
#include"CommandOut.h"
#include"Command.h"

//=============================================================================
/// @brief Constructor.
/// @param cmd - the command which caused the output.
//=============================================================================
CommandOut::CommandOut( const Command& cmd )
    :m_cmd(cmd)
{
}

//=============================================================================
// Function Name: print
/// @brief Add output for the command. Maximum line length is 1023.
/// @param format - the formatted text to print.
/// @param ... - argmuents for the format character string.
//=============================================================================
void CommandOut::print( const char* format, ... )
{
    if( m_lines.size() == 0 )
    {
        m_lines.push_back( string("") );
    }
    char* str = new char[1024];
    va_list ap;
    va_start( ap, format);
    vsnprintf( str, 1023, format, ap );
    va_end(ap);
    str[1023] = '\0';

    string line;
    // until we reach null term or the end of the string
    for( int i = 0; (i < 1024) && (str[i] != '\0'); i++ )
    {
        if( str[i] == '\n' )
        {
            m_lines[m_lines.size()-1] += line; // finished one line
            m_lines.push_back(string("")); // start the next
            line = "";
        }
        else
        {
            line += str[i];
        }
    }
    m_lines[m_lines.size()-1] += line;
    delete[] str;
}
