#ifndef _COMMANDOUT_H_
#define _COMMANDOUT_H_
#include"Command.h"

#include<string>
#include<vector>
using namespace std;

//=============================================================================
/// @class CommandOut
/// @author Daniel Larimer
/// @brief Encapsulates the output of a command.
//=============================================================================
class COMMANDER_API CommandOut
{
    public:
        CommandOut( const Command& cmd );

        void print( const char* format, ... );

		/// @brief Get the output of the command.
		/// @return a string containing the output of the command.
        vector<string> getOutput()const  { return m_lines; }
		/// @brief Get the command which caused the output.
		/// @return a string containing the original command.
        Command        getCommand()const { return m_cmd;   }

    private:
        vector<string> m_lines;
        Command        m_cmd;
};

#endif
