#include <string>
using namespace std;
#include "2dradar.h"
#include <dmath/dMatrix.h>
#include <navmgr/NavManager.h>
#include <GL/gl.h>
#include <math.h>

TwoDRadar::TwoDRadar()
{
 m_center = new float[3];	
 memset(m_center, sizeof(float)*3, 0);
}

void TwoDRadar::makeBG()
{
    #define SIZE 40.0f

    glMatrixMode( GL_PROJECTION );
    glPushMatrix();
    glLoadIdentity();
    
    int winsize[4];
    glGetIntegerv( GL_VIEWPORT, winsize );
    float width = winsize[2], height = winsize[3];

    glOrtho( 0.0f, width, 0.0f, height, -100.0f, 100.0f );
    glMatrixMode( GL_MODELVIEW );
    glPushMatrix();
    glLoadIdentity();

    glPushAttrib( GL_ALL_ATTRIB_BITS );
    glDisable( GL_LIGHTING );
    glDisable( GL_BLEND );
    glPolygonMode( GL_FRONT_AND_BACK, GL_FILL );
    glLineWidth( 2.0f );
    
    glPointSize(5);
    glScalef( SIZE, SIZE, 1.0f );
    glTranslatef( width/SIZE - 1.0f, 1.0f, 0.0f);
    /*
    glPushMatrix();

    dVec3 x(1.0f, 0.0f, 0.0f), y(0.0f, 0.0f, 1.0f), z(0.0f, 1.0f, 0.0f);

    dMatrix mat = NavManager::getMatrix();
    mat.setTrans( 0.0f, 0.0f, 0.0f );
    float* p_mat = mat.ptr();
    glMultMatrixf( p_mat );

    glColor3f(1.0f, 0.0f, 0.0f) ;
    glBegin(GL_LINES) ;
    glVertex3f(0.f, 0.f, 0.f) ;
    glVertex3f(x.x(), x.z(), -x.y()) ;

    glColor3f(0.0f, 1.0f, 0.0f) ;
    glVertex3f(0.f, 0.f, 0.f) ;
    glVertex3f(y.x(), y.z(), -y.y()) ;

    glColor3f(0.0f, 0.0f, 1.0f) ;
    glVertex3f(0.f, 0.f, 0.f) ;
    glVertex3f(z.x(), z.z(), -z.y()) ;
    glEnd();

    glPopMatrix();

    */
    //Cout draw the border around the radar
    float angle;
    glColor3f(1.0f, 1.0f, 1.0f) ;
    glBegin(GL_LINE_LOOP);
    for (angle = 0; angle <= 360; angle += 5)
    {
      glVertex2f(cosf(DEG2RAD(angle)), sinf(DEG2RAD(angle)));
    }
    glEnd();

    //Draw the actual radar
    glEnable(GL_BLEND) ;
    glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA) ;
    glColor4f(1.f, 1.f, 1.f, .2f) ;
    glBegin(GL_POLYGON);
    for (angle = 0; angle <= 360; angle += 5)
    {
      glVertex3f(cosf(DEG2RAD(angle)), sinf(DEG2RAD(angle)), 0.0f);
    }
    glEnd();


    //Try my sorry attempt at a 2d radar

    glDisable(GL_DEPTH_TEST);
    glDisable(GL_BLEND);
    glEnable(GL_POINT_SMOOTH);
    glColor4f(1.f, 0.f, 0.f, .2f) ;
    glBegin(GL_POINTS);
    //Paint me at the center
	glVertex2f(0,0);
    glColor4f(0.f, 0.f, 0.f, .2f) ;
    //hack for 1 type of data on radar
	 map<string, float*>  Data = m_data[m_types[0]];
	 map<string, float*>::iterator MyData = Data.begin();
	while (MyData != Data.end())
	{
		if (Distance(MyData->second, m_center) < m_radius)	
		{
			float* Temp = MyData->second;
			//Yes, it matters that much (the sauce that is )
			float A1 = Temp[0] ;
			float A2 = Temp[1] ;
			float T1  = m_center[0];
			//It'ssss baaaack
			float T2  = m_center[1];
			//Final
			float F1 = T1 - A1;
			float F2 = T2 - A2;
			F1 = F1 / m_radius * SIZE;
			F2 = F2 / m_radius * SIZE;
			//Rescale issue *2
			F1 = F1/SIZE;
			F2 = F2/SIZE;
			glVertex2f(F1, F2);
		}
		MyData++;
	}
    glEnd();
    glDisable(GL_POINT_SMOOTH);
    //Restore call stack
    glPopAttrib() ;
    glPopMatrix();
    glMatrixMode( GL_PROJECTION );
    glPopMatrix();
    glMatrixMode( GL_MODELVIEW );
}

int TwoDRadar::Distance(float* A, float* B)
{
	if (A == NULL || B==NULL)
		return -1;
	return (int)sqrt(pow((double)((B[0] - A[0])),2.0) + pow((double)((B[1] - A[1])),2.0) + pow(((double)(B[2] - A[2])),2.0));
}
void TwoDRadar::addPointType(const string& Name)
{
	m_types.push_back(Name);
}
void TwoDRadar::removePointType(const string& Name)
{
	for (unsigned int i=0; i< m_types.size(); i++)
	{
		if (m_types[i] == Name)
		{
			m_types.erase(m_types.begin()+i);
		}
	}
}
void TwoDRadar::setCenter(float* Center)
{
	memcpy(m_center, Center, sizeof(float)*3);
}

void TwoDRadar::setRadius(const float& Radius)
{
	m_radius = Radius;
}

void TwoDRadar::addPoint(const string& Type, const string& Name)
{
	float* Data = new float[3];
	memset(Data, sizeof(float)*3, 0);
	m_data[Type][Name] = Data;
}

void TwoDRadar::removePoint(const string& Type, const string& Name)
{

}

void TwoDRadar::redraw()
{
	makeBG();
}

void TwoDRadar::updatePoint(const string& Type, const string& Name, float* Pos)
{
	float* Data = m_data[Type][Name];
	if (Data == NULL)
		return;
	memcpy(Data, Pos, sizeof(float)*3);
}
