#ifndef _2dradar_h_
#define _2dradar_h_
#include <string>
#include <map>
#include <vector>
#include <dcollab/core/radar.h>

#ifdef WIN32
#ifdef DCOLLABCORE_EXPORTS
#define DCOLLABCORE_API __declspec(dllexport)
#else
#define DCOLLABCORE_API __declspec(dllimport)
#endif /* DCOLLABCORE_EXPORTS */
#else
#define DCOLLABCORE_API
#endif /* WIN32 */

using namespace std;

class DCOLLABCORE_API TwoDRadar : public Radar 
{
	public:
	TwoDRadar();
	virtual ~TwoDRadar(){};
	virtual void makeBG();
	virtual void addPointType(const string& Name);
	virtual void removePointType(const string& Name);
	virtual void setRadius(const float& Radius);
	virtual void setCenter(float* Data);
	virtual void addPoint(const string& Type, const string& Name);
	virtual void removePoint(const string& Type, const string& Name);
	virtual void redraw();
	virtual void updatePoint(const string& Type, const string& Name, float* Pos);
	private:

	int Distance(float* A, float* B);
	map<string, map<string,float*> > m_data;
	vector<string> m_types;
	float* m_center;
	float  m_radius;
};
#endif
