#include "cdefines.h"
#include <tracer/Tracer.h>
#include <pexpr/POMessage.h>
#include <pexpr/POTextMsg.h>
#include "avatar.h"
#include "avatarmessagehandler.h"

string AvatarMessageHandler::typeHandled()
{
	return "POTextMsg";
}
bool AvatarMessageHandler::handles(POMessage* AMessage)
{
	if (AMessage->messageType() != "POTextMsg")
		return false;
		
	POTextMsg* Message = (POTextMsg*)AMessage;
	ColonList Temp(Message->getText());
	string Type = Temp.getItem(0);

	if (Type == ADDUSER)
		return true;
	if (Type == REMOVEUSER)
		return true;
	if (Type == UPDATEUSERPOS)
		return true;
	return false;
}

void AvatarMessageHandler::handleMessage(POMessage* AMessage)
{
	if (AMessage->messageType() != "POTextMsg")
		return ;
		
	POTextMsg* Message = (POTextMsg*)AMessage;
	ColonList Temp(Message->getText());
	string Type = Temp.getItem(0);
	//cout <<"Client working on " << Temp.getItem(0) << endl;
	if (Type == ADDUSER)
		AddUser(Temp);
	if (Type == REMOVEUSER)
		RemoveUser(Temp);
	if (Type == UPDATEUSERPOS)
		UpdatePos(Temp);
}

void AvatarMessageHandler::RemoveUser(ColonList& AMessage)
{
	//cout << "Removing user\n";
	string UserName = AMessage.getItem(1);
	for (unsigned int i=0; i< m_avatarlist.size(); i++)
	{
		if (m_avatarlist[i]->getName() == UserName)
			m_avatarlist[i]->removeModel();
	}
}

void AvatarMessageHandler::AddUser(ColonList& AMessage)
{
	string UserName = AMessage.getItem(1);
	//cout << "I am trying to add user " << UserName << " to the system\n";
	//cout << "The message is of size " << AMessage.size() << endl;
	for (unsigned int i=0; i< m_avatarlist.size(); i++)
	{
		if (m_avatarlist[i]->getName() == UserName)
		{
			Tracer::error("Cannot add two avatars with the same name");
			return;
		}
	}
	Avatar* newAv = m_creator->createAvatar(AMessage.getItem(2));
	newAv->setName(UserName);
	m_avatarlist.push_back(newAv);
}

void AvatarMessageHandler::UpdatePos(ColonList& AMessage)
{
	//cout <<"Updating position\n";
	float Pos[7];
	unsigned int i;
	//Read the message
	string name = AMessage.getItem(1);
	Avatar* MyAv = NULL;
	bool found = false;
	for (i=0; i<m_avatarlist.size(); i++)
	{
		if (name == m_avatarlist[i]->getName())
		{
			found = true;
			MyAv = m_avatarlist[i];
			break;
		}
	}
	if (!found)
		return;
	for ( i=0; i<7; i++)
		sscanf(AMessage.getItem(i+2).c_str(), "%f", &Pos[i]);
	if (MyAv != NULL)
		MyAv->setPosition(&Pos[0]);
	else
		cout <<"Could not update position for an avatar\n";
}

void AvatarMessageHandler::setCreator(ObjectCreator* OCreator)
{
	m_creator = OCreator;
}
