#include <string>
#include <vector>
using namespace std;
#include <pexpr/POMessage.h>
#include <tracer/Tracer.h>
#include <dcollab/core/object.h>
#include <dcollab/core/handler.h>
#include <dcollab/core/messagehandler.h>
#include <dcollab/core/collabmanager.h>
#include <dcollab/core/communicator.h>
#include <dcollab/core/cdefines.h>
#include <dcollab/core/actionmanager.h>

vector<Object*>   CollabManager::m_objects;
Handler*          CollabManager::m_handler= NULL;
CollabManager*    CollabManager::m_self = NULL;
Communicator*     CollabManager::m_postoffice = NULL;
ActionManager*    CollabManager::m_actions = NULL;

CollabManager::CollabManager()
{
	m_postoffice = new Communicator;
	m_handler    = new Handler;
	m_actions    = new ActionManager;
}

void CollabManager::init()
{
	if (m_self == NULL)
		m_self = new CollabManager;
}

void CollabManager::addObject(Object* NewObject)
{
	if (m_self == NULL)
		return;
	m_self->m_objects.push_back(NewObject);
}

vector<Object*> CollabManager::getObjects()
{
	if (m_self == NULL)
	{
		vector<Object*> Temp;
		return Temp;
	}
	return m_self->m_objects;
}

void CollabManager::addMessageHandler(MessageHandler* NewMHandler)
{
	if (NewMHandler == NULL)
	{
		Tracer::error("Tried to add a null message handler to the collaborative manager, failed");
		return;
	}
	m_self->m_handler->addHandler(NewMHandler);
}

void CollabManager::frame()
{
	if (m_self == NULL)
		return;
	m_self->m_handler->handleMessages(m_self->m_postoffice->getMessages());
	m_self->m_actions->processActions();
}

void CollabManager::connectToServer(const string& Info)
{
	if (m_self == NULL)
		return;
	m_self->m_postoffice->connectToServer(Info);
}
void CollabManager::disconnectFromServer()
{
	if (m_self == NULL)
		return;
	m_self->m_postoffice->disconnectFromServer();
}

Communicator* CollabManager::getCom()
{
	return m_self->m_postoffice;
}

void CollabManager::addAction(Action* NewAction)
{
	m_actions->addAction(NewAction);
}
