#ifndef _collab_manager_h_
#define _collab_manager_h_

#include <vector>
#include <string>
using namespace std;

#include <dmath/dMatrix.h>

#ifdef WIN32
#ifdef DCOLLABCORE_EXPORTS
#define DCOLLABCORE_API __declspec(dllexport)
#else
#define DCOLLABCORE_API __declspec(dllimport)
#endif /* DCOLLABCORE_EXPORTS */
#else
#define DCOLLABCORE_API
#endif /* WIN32 */

class Object;
class Handler;
class Communicator;
class MessageHandler;
class ActionManager;
class Action;

class DCOLLABCORE_API CollabManager
{
	public:
	static void init();
	static void addObject(Object* NewObject);
	static vector<Object*>  getObjects();
	static void addMessageHandler(MessageHandler* NewMHandler);
	static void addAction(Action* NewAction);
	//Check messages, execute them
	static void frame();
	static void connectToServer(const string& Info);
	static void disconnectFromServer();
	static Communicator* getCom();

	private:
	CollabManager();
	static dMatrix         m_old;
	static Communicator*    m_postoffice;
	static CollabManager*   m_self;
	static vector<Object*>  m_objects;
	static Handler*         m_handler;
	static ActionManager*   m_actions;
};
#endif
