#ifndef _communicator_h_
#define _communicator_h_
#include <pexpr/POMessage.h>
#include <pexpr/POAddress.h>
#include <vector>
#include <msgmgr/MessageManager.h>
#include <string>

#ifdef WIN32
#ifdef COLLABDEPENDENCY_EXPORTS
#define COLLABDEPENDENCY_API __declspec(dllexport)
#else
#define COLLABDEPENDENCY_API __declspec(dllimport)
#endif /* COLLABDEPENDENCY_EXPORTS */
#else
#define COLLABDEPENDENCY_API
#endif /* WIN32 */

using namespace std;
class POBox;
class COLLABDEPENDENCY_API Communicator
{
	public:
	Communicator();

	void connectToServer(const string& Info);
	void disconnectFromServer();
	void setPort(const int& Port);

	POMessage* getMessage();
	vector<POMessage*> getMessages();

	void sendMessage(POMessage* AMessage);
	void setTo(POAddress Name);
	void startListen(const int& Port = DEFAULT_MMPORT);
	private:
	POBox*     m_box;
	POAddress    m_serveraddr;
	int          m_port;
};
#endif
