#include <pexpr/POMessage.h>
#include <tracer/Tracer.h>
#include <pexpr/POTextMsg.h>
#include <dutil/ColonList.h>
#include "messagehandler.h"
#include "handler.h"

void Handler::handleMessage(POMessage* AMessage)
{
	for (unsigned int i=0; i<m_handlers.size(); i++)
	{
		if (m_handlers[i]->typeHandled() == AMessage->messageType())
		{
			m_handlers[i]->handleMessage(AMessage);
		}
	}
}

void Handler::handleMessages(vector<POMessage*> AMessage)
{
	for (unsigned int i=0; i< AMessage.size(); i++)
		handleMessage(AMessage[i]);
}

void Handler::addHandler(MessageHandler* AHandler)
{
	if (AHandler == NULL)
	{
		Tracer::error("Tried to add a bad message handler to the handler class");
		return;
	}
	m_handlers.push_back(AHandler);
}
void Handler::removeHandler(MessageHandler* AHandler)
{
	for (unsigned int i=0; i<m_handlers.size(); i++)
	{
		if (m_handlers[i] == AHandler)
		{
			m_handlers.erase(m_handlers.begin()+i);
		}
	}
}
bool Handler::canHandle(POMessage* AMessage)
{
	for (unsigned int i=0; i< m_handlers.size(); i++)
	{
		if (m_handlers[i]->handles(AMessage))
			return true;
	}
	return false;
}
