#ifndef _OBJECT_H_
#define _OBJECT_H_

#include <string>
#include <dmath/dVec3.h>
#include <dmath/dMatrix.h>

#ifdef WIN32
#ifdef DCOLLABCORE_EXPORTS
#define DCOLLABCORE_API __declspec(dllexport)
#else
#define DCOLLABCORE_API __declspec(dllimport)
#endif /* DCOLLABCORE_EXPORTS */
#else
#define DCOLLABCORE_API
#endif /* WIN32 */

using namespace std;
class DCOLLABCORE_API Object
{
	public:
	Object();
	virtual ~Object();

	virtual float* getPosition();
	virtual void   setPosition(float* NewPos);

	string getType();
	void   setType(const string& NewType);

	int    getID();
	void   setID(const int& NewID);

	virtual float  getScale();
	virtual void   setScale(const float& NewScale);

	string getName();
	void   setName(const string& NewName);

	private:
	float  m_position[7];
	string m_type;
	int    m_id;
	float  m_scale;
	string m_name;
};
#endif
