#include <tracer/Tracer.h>
#include <dcollab/core/radar.h>
#include <navmgr/NavManager.h>
#include <dcollab/core/radaraction.h>

RadarAction::RadarAction()
{
	m_old.makeIdentity();
	m_radar = NULL;
}
RadarAction::~RadarAction()
{

}

void RadarAction::setRadar(Radar* NewRadar)
{
	m_radar = NewRadar;	
}

void RadarAction::process()
{
	if (m_radar == NULL)
	{
		Tracer::error("Trying to do a radar action with no radar in the action");
		return;
	}
	if (m_old != NavManager::getMatrix())
	{
		m_old = NavManager::getMatrix();
		float Temp[3];
		Temp[0] = m_old.getTrans().x();
		Temp[1] = m_old.getTrans().y();
		Temp[2] = m_old.getTrans().z();
		m_radar->setCenter(&Temp[0]);
	}
}
