#include "cdefines.h"
#include <tracer/Tracer.h>
#include <pexpr/POMessage.h>
#include <pexpr/POTextMsg.h>
#include "radar.h"
#include "radarmessagehandler.h"

string RadarMessageHandler::typeHandled()
{
	return "POTextMsg";
}
bool RadarMessageHandler::handles(POMessage* AMessage)
{
	if (AMessage->messageType() != "POTextMsg")
		return false;
		
	POTextMsg* Message = (POTextMsg*)AMessage;
	ColonList Temp(Message->getText());
	string Type = Temp.getItem(0);

	if (Type == ADDUSER)
		return true;
	if (Type == REMOVEUSER)
		return true;
	if (Type == UPDATEUSERPOS)
		return true;
	return false;
}

void RadarMessageHandler::handleMessage(POMessage* AMessage)
{
	if (AMessage->messageType() != "POTextMsg")
		return ;
		
	POTextMsg* Message = (POTextMsg*)AMessage;
	ColonList Temp(Message->getText());
	string Type = Temp.getItem(0);
	//cout <<"Client working on " << Temp.getItem(0) << endl;
	if (Type == ADDUSER)
		AddUser(Temp);
	if (Type == REMOVEUSER)
		RemoveUser(Temp);
	if (Type == UPDATEUSERPOS)
		UpdatePos(Temp);
}

void RadarMessageHandler::RemoveUser(ColonList& AMessage)
{
	string UserName = AMessage.getItem(1);
	m_radar->removePoint(RADARATYPE, UserName);
}

void RadarMessageHandler::AddUser(ColonList& AMessage)
{
	string UserName = AMessage.getItem(1);
	m_radar->addPoint(RADARATYPE, UserName);
}

void RadarMessageHandler::UpdatePos(ColonList& AMessage)
{
	float Pos[3];
	//Read the message
	string name = AMessage.getItem(1);
	for (int i=0; i<3; i++)
		sscanf(AMessage.getItem(i+2).c_str(), "%f", &Pos[i]);
	m_radar->updatePoint(RADARATYPE, name, &Pos[0]);
}

void RadarMessageHandler::setRadar(Radar* NewRadar)
{
	m_radar= NewRadar;
}
