#include <pexpr/POTextMsg.h>
#include <dcollab/core/cdefines.h>
#include <dcollab/core/communicator.h>
#include <dcollab/core/serveravatarmhandler.h>
#include <services/CollabServer/cserverservice.h>
#include <servicemgr/GServiceManager.h>
#include <iostream>
using namespace std;


ServerAvatarHandler::ServerAvatarHandler()
{
	m_server = (CServerService*)GServiceManager::getService("CServerService");
}
bool ServerAvatarHandler::handles(POMessage* AMessage)
{
	//Make sure we are dealing with a text message
	if (AMessage->messageType() != "POTextMsg")
		return false;

	//Get the text message
	POTextMsg* TMsg;
	TMsg = (POTextMsg*) AMessage;
	//Parse the message
	ColonList Test(TMsg->getText());
	if (Test.getItem(0) == ADDUSER)
		return true;
	else if (Test.getItem(0) == REMOVEUSER)
		return true;
	else
		return false;
}
void ServerAvatarHandler::handleMessage(POMessage* AMessage)
{
	//Make sure we are dealing with a text message
	if (AMessage->messageType() != "POTextMsg")
		return ;

	POTextMsg* Message = (POTextMsg*)AMessage;
	ColonList Temp(Message->getText());
	string Type = Temp.getItem(0);
	//cout << "Avatar server working on message w/ tag " << Temp.getItem(0) << endl;
	if (Type == ADDUSER)
		addUser(Temp, AMessage);
	if (Type == REMOVEUSER)
		removeUser(Temp, AMessage);
}

void ServerAvatarHandler::addUser(ColonList& Message, POMessage* Msg)
{
	unsigned int i;
	POAddress BLAH = Msg->getSource();
	//Check to see if they are in the list of people
	string Name = Message.getItem(1);	
	for (i=0; i<m_names.size(); i++)
	{
		if (m_names[i] == Name)
			return;
	}
	//cout << "Adding user " << Name <<  " to the server\n";
	//If they are not then let everyone know they are being added to the system
	vector<POAddress> List = m_server->getAddresses();
	//cout << "There are " << List.size() << " number of users in the system\n";
	bool Found = false;

	for (i=0; i< List.size(); i++)
	{
		if (List[i] == Msg->getSource())
			Found = true;
	}
	if (Found)
	{
		Tracer::error("trying to add a duplicate user to the system");
		return;
	}
	//Let the other people know about the user
	m_server->forwardMessage(Msg);
	//Then let the new person know about everyone else in the system
	m_server->getCom()->setTo(BLAH);
	for (i=0; i<m_addMessages.size(); i++)
	{
		//cout << "Sending an add user message to " << Name << "\n";
		m_server->getCom()->sendMessage(m_addMessages[i]);
	}
	//Add new person to the list of people in the system
	m_addMessages.push_back(Msg);
	m_names.push_back(Name);
	//Add the persons address to the server
	m_server->addPair(Name, BLAH);
	//m_server->addAddress(Msg->getSource());
	//m_server->addName(Name);
}
void ServerAvatarHandler::removeUser(ColonList& Message, POMessage* Msg)
{
	//cout << "Removing user in server\n";
 	string Name = Message.getItem(1);
	for (unsigned int i=0; i< m_names.size(); i++)
	{
		if (m_names[i] == Name)
		{
			m_names.erase(m_names.begin() + i);
			m_addMessages.erase(m_addMessages.begin() + i);
			return;
		}
	}
}
