#include <tracer/Tracer.h>
#include <dmath/dVec3.h>
#include <dmath/dMatrix.h>
#include <string>
#include <vector>
using namespace std;
#include "osgavatar.h"
#include <osgDB/Registry>
#include <dosg/dosgdep.h>

OsgAvatar::OsgAvatar()
{
	//DOsg::init();
	DOSG::init();
	m_node =  new osg::MatrixTransform;
}

OsgAvatar::~OsgAvatar()
{
}

void OsgAvatar::loadModel(const string& FileName)
{
	m_model = readNodeFile(FileName.c_str());
	m_node->addChild(m_model);
	DOSG::getWorld()->addChild(m_node);
}

void OsgAvatar::removeModel()
{
	DOSG::getWorld()->removeChild(m_node);
}

void OsgAvatar::setScale(const float& NewScale)
{
	Object::setScale(NewScale);
	//m_node->scale(NewScale, NewScale, NewScale);
}

void OsgAvatar::setPosition(float* Temp)
{
//	for (int i=0; i<7; i++)
//		cout << Temp[i] << " " ;
//	cout << endl;
    osg::Matrix view;
    view.makeIdentity();
    view = view.translate(Temp[0], Temp[1], Temp[2]) * view.rotate(Temp[6], Temp[3], Temp[4], Temp[5]);
    //osg::Quat MyQuat(Temp[3], Temp[4], Temp[5], Temp[6]);
    //view.makeRotate(MyQuat);
    m_node->setMatrix(view);
}
