#ifndef _OSGAVATAR_H_
#define _OSGAVATAR_H_
#include <dcollab/core/avatar.h>
#include<osg/MatrixTransform>

#ifdef WIN32
#ifdef DOSGCOLLAB_EXPORTS
#define DOSGCOLLAB_API __declspec(dllexport)
#else
#define DOSGCOLLAB_API __declspec(dllimport)
#endif /* DOSGCOLLAB_EXPORTS */
#else
#define DOSGCOLLAB_API
#endif /* WIN32 */

class DOSGCOLLAB_API OsgAvatar : public Avatar
{
	public:
	OsgAvatar();
	~OsgAvatar();

	virtual void loadModel(const string& FileName);
	virtual void removeModel();

	virtual void   setPosition(float* NewPos);
	virtual void   setScale(const float& NewScale);

	private:
	osg::MatrixTransform* m_node;
	osg::Node* m_model;
};
#endif
