#ifndef _CAUGMENT_H_
#define _CAUGMENT_H_
#include<dgl/libdgl/DglApp.h>
#include<dgl/libdgl/cdgl.h>

//=============================================================================
/// @class CDglApp
/// @brief To write C applications, rather than C++ applications, the functions
/// defined in cdgl.h and cdgl.cpp are used and p[ass the information to this 
/// class.
///
/// Those functions set up the CDglApp which is derived from DglApp. This object
/// maintains the callback for use by DIVERSE and calls them when necessary.
//=============================================================================
class LIBDGL_API CDglApp: public DglApp
{
    public:
        bool onMouseEvent(DMouseEvent* evt);
        bool onWandEvent(DWandEvent* evt);
        bool onKeyEvent(DKeyEvent* evt);
        bool onTrackerEvent(DTrackerEvent* evt);
        void draw()const;
        void preNavDraw()const;
        void postProcess();
        void initContext();
        void initContextLists();
        void preProcess();
        int  postConfig();
        int  preConfig();
    
        static void init(int argc, char** argv);
        static void runDgl();
        static void startDgl();

        static void*              m_data;
        static dglPostConfigCB    m_postconfig;
        static dglPreConfigCB     m_preconfig;
        static dglDisplayCB       m_display;
        static dglPreNavDisplayCB m_pndsp;
        static dglPreProcessCB       m_preproc;
        static dglPostProcessCB       m_postproc;
        static dglInitContextCB       m_contextproc;
        static dglInitContextListsCB       m_contextlistsproc;
        static dglWandCB                 m_cwand;
        static dglKeyCB                 m_ckey;
        static dglMouseCB                 m_cmouse;
        static dglTrackerCB                 m_ctracker;
        static CDglApp* instance() { return m_app; }
    private:
        CDglApp( int argc, char** argv, const string& name = "CDglApp" );
        static bool m_init;
        static CDglApp* m_app;
};

#endif
