#ifndef _DGLAPP_H
#define _DGLAPP_H
#include<libdiverse/DiverseApp.h>
#include<dgl/dglcore/DGLAugmentInterface.h>

#ifdef WIN32
#ifdef LIBDGL_EXPORTS
#define LIBDGL_API __declspec(dllexport)
#else
#define LIBDGL_API __declspec(dllimport)
#endif /* LIBDGL_EXPORTS */
#else
#define LIBDGL_API
#endif /* WIN32 */


//=============================================================================
/// @class DglApp 
/// @brief Initializes DGL defaults for the DIVERSE application.
//=============================================================================
class LIBDGL_API DglApp : public DiverseApp, public DGLAugmentInterface
{
    public:
        DglApp( int argc=0, char** argv=NULL, const string& cfgfile = "diverse.xml", bool init = true );
        ~DglApp();

        void setupRegistry( const string& filename = "diverse.xml" );
        void initModules();

        void  setIOD( const float& iod );
        float getIOD()const;

        void setNearClip( const float& nclip );
        void setFarClip( const float& fclip );

        float getNearClip()const;
        float getFarClip()const;

        void addAugment( DGLAugmentInterface* arg );
        void removeAugment( DGLAugmentInterface* arg );

		/// @brief Not implemented.
        void draw()const {};

    private:
        bool m_setup;

};
#endif
