#ifndef _CDGL_H_
#define _CDGL_H_
//#include<GL/gl.h>

#ifdef WIN32
#ifdef LIBDGL_EXPORTS
#define LIBDGL_API __declspec(dllexport)
#else
#define LIBDGL_API __declspec(dllimport)
#endif /* LIBDGL_EXPORTS */
#else
#define LIBDGL_API
#endif /* WIN32 */

#include <eventmgr/devents.h>
/// @var typedef void LIBDGL_API (*dglDisplayCB)(void)
/// @brief pointer to a display callback function.
typedef void LIBDGL_API (*dglDisplayCB)(void);
/// @var typedef void LIBDGL_API (*dglPreNavDisplayCB)(void)
/// @brief pointer to a preNav display callback function.
typedef void LIBDGL_API (*dglPreNavDisplayCB)(void);
/// @var typedef void LIBDGL_API (*dglPreConfigCB)(void)
/// @brief pointer to a preConfig callback function.
typedef void LIBDGL_API (*dglPreConfigCB)(void);
/// @var typedef void LIBDGL_API (*dglPostConfigCB)(void)
/// @brief pointer to a postConfig callback function.
typedef void LIBDGL_API (*dglPostConfigCB)(void);
/// @var typedef void LIBDGL_API (*dglPreProcessCB)(void)
/// @brief pointer to a preProcess callback function.
typedef void LIBDGL_API (*dglPreProcessCB)(void);
/// @var typedef void LIBDGL_API (*dglPostProcessCB)(void)
/// @brief pointer to a postProcess callback function.
typedef void LIBDGL_API (*dglPostProcessCB)(void);
/// @var typedef void LIBDGL_API (*dglInitContextCB)(void)
/// @brief pointer to an initContext callback function.
typedef void LIBDGL_API (*dglInitContextCB)(void);
/// @var typedef void LIBDGL_API (*dglInitContextListsCB)(void)
/// @brief pointer to an initContextLists callback function.
typedef void LIBDGL_API (*dglInitContextListsCB)(void);
/// @var typedef bool LIBDGL_API (*dglWandCB)(DWandEvent* DEvent)
/// @brief pointer to a onWandEvent callback function.
typedef bool LIBDGL_API (*dglWandCB)(DWandEvent* DEvent);
/// @var typedef bool LIBDGL_API (*dglKeyCB)(DKeyEvent* DEvent)
/// @brief pointer to a onKeyEvent callback function.
typedef bool LIBDGL_API (*dglKeyCB)(DKeyEvent* DEvent);
/// @var typedef bool LIBDGL_API (*dglTrackerCB)(DTrackerEvent* DEvent)
/// @brief pointer to a onTrackerEvent callback function.
typedef bool LIBDGL_API (*dglTrackerCB)(DTrackerEvent* DEvent);
/// @var typedef bool LIBDGL_API (*dglMouseCB)(DMouseEvent* DEvent)
/// @brief pointer to a onMouseEvent callback function.
typedef bool LIBDGL_API (*dglMouseCB)(DMouseEvent* DEvent);

extern "C"
{
    void LIBDGL_API dglInit( int argc, char** argv );
    void LIBDGL_API dglRun();
    void LIBDGL_API dglStart();
    bool LIBDGL_API dglIsRunning();
    void LIBDGL_API dglFrame();
    void LIBDGL_API dglSync();
    void LIBDGL_API dglPreConfigCallback( dglPreConfigCB cb);
    void LIBDGL_API dglPostConfigCallback( dglPostConfigCB cb);
    void LIBDGL_API dglDisplayCallback( dglDisplayCB cb);
    void LIBDGL_API dglPreNavDisplayCallback( dglPreNavDisplayCB cb);
    void LIBDGL_API dglPreProcessCallback( dglPreProcessCB cb);
    void LIBDGL_API dglPostProcessCallback( dglPostProcessCB cb);
    void LIBDGL_API dglInitContextCallback( dglInitContextCB cb );
    void LIBDGL_API dglInitContextListsCallback( dglInitContextListsCB cb );
    void LIBDGL_API dglKeyCallback( dglKeyCB cb);
    void LIBDGL_API dglMouseCallback( dglMouseCB cb);
    void LIBDGL_API dglTrackerCallback( dglTrackerCB cb);
    void LIBDGL_API dglWandCallback( dglWandCB cb);
    void LIBDGL_API *dglGetData();
    void LIBDGL_API dglSetData(void* Data);
}

#endif
