#ifndef _DOSGAPP_H
#define _DOSGAPP_H
#include<dmath/dmath.h>
#include<libdiverse/DiverseApp.h>
#include<dosg/DOSG.h>

#ifdef WIN32
#ifdef DOSG_EXPORTS
#define DOSG_API __declspec(dllexport)
#else
#define DOSG_API __declspec(dllimport)
#endif /* DOSG_EXPORTS */
#else
#define DOSG_API
#endif /* WIN32 */


//=============================================================================
/// @class DOsgApp
/// @brief Initializes DOSG defaults.
//=============================================================================
class DOSG_API DOsgApp : public DiverseApp
{
    public:
        DOsgApp(int argc, char** argv, const string& cfgfile = "diverse.xml", bool init = true );
        ~DOsgApp();

        void initModules();
        void setupRegistry( const string& cfgfile );

        osg::Group* getWorld()const;
        osg::Group* getEther()const;
        osg::Group* getRoot()const;

    private:
        bool    m_setup;

};
#endif
