//============================================================================
// keyConverter.h - converts keyboard key string to/from DKeyEvent::Key enum
// value names
//
// Created 6/9/03 By Patrick Shinpaugh
//=============================================================================
#include "keyConverter.h"

using namespace std;

/// @brief Converts a Key code to a Key code name string.
/// @param keycode - the Key code to convert.
/// @return a string containing the Key code name.
string keyConverter::translateKeyToString( int keycode )
{
    switch ( keycode )
    {
		case DKeyEvent::Key_Escape:
			return "Key_Escape";
		case DKeyEvent::Key_Tab:
			return "Key_Tab";
		case DKeyEvent::Key_Backtab:
			return "Key_Backtab";
		case DKeyEvent::Key_Backspace:
			return "Key_Backspace";
		case DKeyEvent::Key_Return:
			return "Key_Return";
		case DKeyEvent::Key_Enter:
			return "Key_Enter";
		case DKeyEvent::Key_Insert:
			return "Key_Insert";
		case DKeyEvent::Key_Delete:
			return "Key_Delete";
		case DKeyEvent::Key_Pause:
			return "Key_Pause";
		case DKeyEvent::Key_Print:
			return "Key_Print";
		case DKeyEvent::Key_SysReq:
			return "Key_SysReq";
		case DKeyEvent::Key_Home:
			return "Key_Home";
		case DKeyEvent::Key_End:
			return "Key_End";
		case DKeyEvent::Key_Left:
			return "Key_Left";
		case DKeyEvent::Key_Up:
			return "Key_Up";
		case DKeyEvent::Key_Right:
			return "Key_Right";
		case DKeyEvent::Key_Down:
			return "Key_Down";
		case DKeyEvent::Key_Prior:
			return "Key_Prior";
		case DKeyEvent::Key_Next:
			return "Key_Next";
		case DKeyEvent::Key_Shift:
			return "Key_Shift";
		case DKeyEvent::Key_Control:
			return "Key_Control";
		case DKeyEvent::Key_Meta:
			return "Key_Meta";
		case DKeyEvent::Key_Alt:
			return "Key_Alt";
		case DKeyEvent::Key_CapsLock:
			return "Key_CapsLock";
		case DKeyEvent::Key_NumLock:
			return "Key_NumLock";
		case DKeyEvent::Key_ScrollLock:
			return "Key_ScrollLock";
		case DKeyEvent::Key_F1:
			return "Key_F1";
		case DKeyEvent::Key_F2:
			return "Key_F2";
		case DKeyEvent::Key_F3:
			return "Key_F3";
		case DKeyEvent::Key_F4:
			return "Key_F4";
		case DKeyEvent::Key_F5:
			return "Key_F5";
		case DKeyEvent::Key_F6:
			return "Key_F6";
		case DKeyEvent::Key_F7:
			return "Key_F7";
		case DKeyEvent::Key_F8:
			return "Key_F8";
		case DKeyEvent::Key_F9:
			return "Key_F9";
		case DKeyEvent::Key_F10:
			return "Key_F10";
		case DKeyEvent::Key_F11:
			return "Key_F11";
		case DKeyEvent::Key_F12:
			return "Key_F12";
		case DKeyEvent::Key_F13:
			return "Key_F13";
		case DKeyEvent::Key_F14:
			return "Key_F14";
		case DKeyEvent::Key_F15:
			return "Key_F15";
		case DKeyEvent::Key_F16:
			return "Key_F16";
		case DKeyEvent::Key_F17:
			return "Key_F17";
		case DKeyEvent::Key_F18:
			return "Key_F18";
		case DKeyEvent::Key_F19:
			return "Key_F19";
		case DKeyEvent::Key_F20:
			return "Key_F20";
		case DKeyEvent::Key_F21:
			return "Key_F21";
		case DKeyEvent::Key_F22:
			return "Key_F22";
		case DKeyEvent::Key_F23:
			return "Key_F23";
		case DKeyEvent::Key_F24:
			return "Key_F24";
		case DKeyEvent::Key_F25:
			return "Key_F25";
		case DKeyEvent::Key_F26:
			return "Key_F26";
		case DKeyEvent::Key_F27:
			return "Key_F27";
		case DKeyEvent::Key_F28:
			return "Key_F28";
		case DKeyEvent::Key_F29:
			return "Key_F29";
		case DKeyEvent::Key_F30:
			return "Key_F30";
		case DKeyEvent::Key_F31:
			return "Key_F31";
		case DKeyEvent::Key_F32:
			return "Key_F32";
		case DKeyEvent::Key_F33:
			return "Key_F33";
		case DKeyEvent::Key_F34:
			return "Key_F34";
		case DKeyEvent::Key_F35:
			return "Key_F35";
		case DKeyEvent::Key_Super_L:
			return "Key_Super_L";
		case DKeyEvent::Key_Super_R:
			return "Key_Super_R";
		case DKeyEvent::Key_Menu:
			return "Key_Menu";
		case DKeyEvent::Key_Hyper_L:
			return "Key_Hyper_L";
		case DKeyEvent::Key_Hyper_R:
			return "Key_Hyper_R";
		case DKeyEvent::Key_Help:
			return "Key_Help";
		case DKeyEvent::Key_Direction_L:
			return "Key_Direction_L";
		case DKeyEvent::Key_Direction_R:
			return "Key_Direction_R";
		case DKeyEvent::Key_Space:
			return "Key_Space";
		case DKeyEvent::Key_Exclam:
			return "Key_Exclam";
		case DKeyEvent::Key_QuoteDbl:
			return "Key_QuoteDbl";
		case DKeyEvent::Key_NumberSign:
			return "Key_NumberSign";
		case DKeyEvent::Key_Dollar:
			return "Key_Dollar";
		case DKeyEvent::Key_Percent:
			return "Key_Percent";
		case DKeyEvent::Key_Ampersand:
			return "Key_Ampersand";
		case DKeyEvent::Key_Apostrophe:
			return "Key_Apostrophe";
		case DKeyEvent::Key_ParenLeft:
			return "Key_ParenLeft";
		case DKeyEvent::Key_ParenRight:
			return "Key_ParenRight";
		case DKeyEvent::Key_Asterisk:
			return "Key_Asterisk";
		case DKeyEvent::Key_Plus:
			return "Key_Plus";
		case DKeyEvent::Key_Comma:
			return "Key_Comma";
		case DKeyEvent::Key_Minus:
			return "Key_Minus";
		case DKeyEvent::Key_Period:
			return "Key_Period";
		case DKeyEvent::Key_Slash:
			return "Key_Slash";
		case DKeyEvent::Key_0:
			return "Key_0";
		case DKeyEvent::Key_1:
			return "Key_1";
		case DKeyEvent::Key_2:
			return "Key_2";
		case DKeyEvent::Key_3:
			return "Key_3";
		case DKeyEvent::Key_4:
			return "Key_4";
		case DKeyEvent::Key_5:
			return "Key_5";
		case DKeyEvent::Key_6:
			return "Key_6";
		case DKeyEvent::Key_7:
			return "Key_7";
		case DKeyEvent::Key_8:
			return "Key_8";
		case DKeyEvent::Key_9:
			return "Key_9";
		case DKeyEvent::Key_Colon:
			return "Key_Colon";
		case DKeyEvent::Key_Semicolon:
			return "Key_Semicolon";
		case DKeyEvent::Key_Less:
			return "Key_Less";
		case DKeyEvent::Key_Equal:
			return "Key_Equal";
		case DKeyEvent::Key_Greater:
			return "Key_Greater";
		case DKeyEvent::Key_Question:
			return "Key_Question";
		case DKeyEvent::Key_At:
			return "Key_At";
		case DKeyEvent::Key_A:
			return "Key_A";
		case DKeyEvent::Key_B:
			return "Key_B";
		case DKeyEvent::Key_C:
			return "Key_C";
		case DKeyEvent::Key_D:
			return "Key_D";
		case DKeyEvent::Key_E:
			return "Key_E";
		case DKeyEvent::Key_F:
			return "Key_F";
		case DKeyEvent::Key_G:
			return "Key_G";
		case DKeyEvent::Key_H:
			return "Key_H";
		case DKeyEvent::Key_I:
			return "Key_I";
		case DKeyEvent::Key_J:
			return "Key_J";
		case DKeyEvent::Key_K:
			return "Key_K";
		case DKeyEvent::Key_L:
			return "Key_L";
		case DKeyEvent::Key_M:
			return "Key_M";
		case DKeyEvent::Key_N:
			return "Key_N";
		case DKeyEvent::Key_O:
			return "Key_O";
		case DKeyEvent::Key_P:
			return "Key_P";
		case DKeyEvent::Key_Q:
			return "Key_Q";
		case DKeyEvent::Key_R:
			return "Key_R";
		case DKeyEvent::Key_S:
			return "Key_S";
		case DKeyEvent::Key_T:
			return "Key_T";
		case DKeyEvent::Key_U:
			return "Key_U";
		case DKeyEvent::Key_V:
			return "Key_V";
		case DKeyEvent::Key_W:
			return "Key_W";
		case DKeyEvent::Key_X:
			return "Key_X";
		case DKeyEvent::Key_Y:
			return "Key_Y";
		case DKeyEvent::Key_Z:
			return "Key_Z";
		case DKeyEvent::Key_BracketLeft:
			return "Key_BracketLeft";
		case DKeyEvent::Key_Backslash:
			return "Key_Backslash";
		case DKeyEvent::Key_BracketRight:
			return "Key_BracketRight";
		case DKeyEvent::Key_AsciiCircum:
			return "Key_AsciiCircum";
		case DKeyEvent::Key_Underscore:
			return "Key_Underscore";
		case DKeyEvent::Key_QuoteLeft:
			return "Key_QuoteLeft";
		case DKeyEvent::Key_BraceLeft:
			return "Key_BraceLeft";
		case DKeyEvent::Key_Bar:
			return "Key_Bar";
		case DKeyEvent::Key_BraceRight:
			return "Key_BraceRight";
		case DKeyEvent::Key_AsciiTilde:
			return "Key_AsciiTilde";
		case DKeyEvent::Key_nobreakspace:
			return "Key_nobreakspace";
		case DKeyEvent::Key_exclamdown:
			return "Key_exclamdown";
		case DKeyEvent::Key_cent:
			return "Key_cent";
		case DKeyEvent::Key_sterling:
			return "Key_sterling";
		case DKeyEvent::Key_currency:
			return "Key_currency";
		case DKeyEvent::Key_yen:
			return "Key_yen";
		case DKeyEvent::Key_brokenbar:
			return "Key_brokenbar";
		case DKeyEvent::Key_section:
			return "Key_section";
		case DKeyEvent::Key_diaeresis:
			return "Key_diaeresis";
		case DKeyEvent::Key_copyright:
			return "Key_copyright";
		case DKeyEvent::Key_ordfeminine:
			return "Key_ordfeminine";
		case DKeyEvent::Key_guillemotleft:
			return "Key_guillemotleft";
		case DKeyEvent::Key_notsign:
			return "Key_notsign";
		case DKeyEvent::Key_hyphen:
			return "Key_hyphen";
		case DKeyEvent::Key_registered:
			return "Key_registered";
		case DKeyEvent::Key_macron:
			return "Key_macron";
		case DKeyEvent::Key_degree:
			return "Key_degree";
		case DKeyEvent::Key_plusminus:
			return "Key_plusminus";
		case DKeyEvent::Key_twosuperior:
			return "Key_twosuperior";
		case DKeyEvent::Key_threesuperior:
			return "Key_threesuperior";
		case DKeyEvent::Key_acute:
			return "Key_acute";
		case DKeyEvent::Key_mu:
			return "Key_mu";
		case DKeyEvent::Key_paragraph:
			return "Key_paragraph";
		case DKeyEvent::Key_periodcentered:
			return "Key_periodcentered";
		case DKeyEvent::Key_cedilla:
			return "Key_cedilla";
		case DKeyEvent::Key_onesuperior:
			return "Key_onesuperior";
		case DKeyEvent::Key_masculine:
			return "Key_masculine";
		case DKeyEvent::Key_guillemotright:
			return "Key_guillemotright";
		case DKeyEvent::Key_onequarter:
			return "Key_onequarter";
		case DKeyEvent::Key_onehalf:
			return "Key_onehalf";
		case DKeyEvent::Key_threequarters:
			return "Key_threequarters";
		case DKeyEvent::Key_questiondown:
			return "Key_questiondown";
		case DKeyEvent::Key_Agrave:
			return "Key_Agrave";
		case DKeyEvent::Key_Aacute:
			return "Key_Aacute";
		case DKeyEvent::Key_Acircumflex:
			return "Key_Acircumflex";
		case DKeyEvent::Key_Atilde:
			return "Key_Atilde";
		case DKeyEvent::Key_Adiaeresis:
			return "Key_Adiaeresis";
		case DKeyEvent::Key_Aring:
			return "Key_Aring";
		case DKeyEvent::Key_AE:
			return "Key_AE";
		case DKeyEvent::Key_Ccedilla:
			return "Key_Ccedilla";
		case DKeyEvent::Key_Egrave:
			return "Key_Egrave";
		case DKeyEvent::Key_Eacute:
			return "Key_Eacute";
		case DKeyEvent::Key_Ecircumflex:
			return "Key_Ecircumflex";
		case DKeyEvent::Key_Ediaeresis:
			return "Key_Ediaeresis";
		case DKeyEvent::Key_Igrave:
			return "Key_Igrave";
		case DKeyEvent::Key_Iacute:
			return "Key_Iacute";
		case DKeyEvent::Key_Icircumflex:
			return "Key_Icircumflex";
		case DKeyEvent::Key_Idiaeresis:
			return "Key_Idiaeresis";
		case DKeyEvent::Key_ETH:
			return "Key_ETH";
		case DKeyEvent::Key_Ntilde:
			return "Key_Ntilde";
		case DKeyEvent::Key_Ograve:
			return "Key_Ograve";
		case DKeyEvent::Key_Oacute:
			return "Key_Oacute";
		case DKeyEvent::Key_Ocircumflex:
			return "Key_Ocircumflex";
		case DKeyEvent::Key_Otilde:
			return "Key_Otilde";
		case DKeyEvent::Key_Odiaeresis:
			return "Key_Odiaeresis";
		case DKeyEvent::Key_multiply:
			return "Key_multiply";
		case DKeyEvent::Key_Ooblique:
			return "Key_Ooblique";
		case DKeyEvent::Key_Ugrave:
			return "Key_Ugrave";
		case DKeyEvent::Key_Uacute:
			return "Key_Uacute";
		case DKeyEvent::Key_Ucircumflex:
			return "Key_Ucircumflex";
		case DKeyEvent::Key_Udiaeresis:
			return "Key_Udiaeresis";
		case DKeyEvent::Key_Yacute:
			return "Key_Yacute";
		case DKeyEvent::Key_THORN:
			return "Key_THORN";
		case DKeyEvent::Key_ssharp:
			return "Key_ssharp";
		case DKeyEvent::Key_agrave:
			return "Key_agrave";
		case DKeyEvent::Key_aacute:
			return "Key_aacute";
		case DKeyEvent::Key_acircumflex:
			return "Key_acircumflex";
		case DKeyEvent::Key_atilde:
			return "Key_atilde";
		case DKeyEvent::Key_adiaeresis:
			return "Key_adiaeresis";
		case DKeyEvent::Key_aring:
			return "Key_aring";
		case DKeyEvent::Key_ae:
			return "Key_ae";
		case DKeyEvent::Key_ccedilla:
			return "Key_ccedilla";
		case DKeyEvent::Key_egrave:
			return "Key_egrave";
		case DKeyEvent::Key_eacute:
			return "Key_eacute";
		case DKeyEvent::Key_ecircumflex:
			return "Key_ecircumflex";
		case DKeyEvent::Key_ediaeresis:
			return "Key_ediaeresis";
		case DKeyEvent::Key_igrave:
			return "Key_igrave";
		case DKeyEvent::Key_iacute:
			return "Key_iacute";
		case DKeyEvent::Key_icircumflex:
			return "Key_icircumflex";
		case DKeyEvent::Key_idiaeresis:
			return "Key_idiaeresis";
		case DKeyEvent::Key_eth:
			return "Key_eth";
		case DKeyEvent::Key_ntilde:
			return "Key_ntilde";
		case DKeyEvent::Key_ograve:
			return "Key_ograve";
		case DKeyEvent::Key_oacute:
			return "Key_oacute";
		case DKeyEvent::Key_ocircumflex:
			return "Key_ocircumflex";
		case DKeyEvent::Key_otilde:
			return "Key_otilde";
		case DKeyEvent::Key_odiaeresis:
			return "Key_odiaeresis";
		case DKeyEvent::Key_division:
			return "Key_division";
		case DKeyEvent::Key_oslash:
			return "Key_oslash";
		case DKeyEvent::Key_ugrave:
			return "Key_ugrave";
		case DKeyEvent::Key_uacute:
			return "Key_uacute";
		case DKeyEvent::Key_ucircumflex:
			return "Key_ucircumflex";
		case DKeyEvent::Key_udiaeresis:
			return "Key_udiaeresis";
		case DKeyEvent::Key_yacute:
			return "Key_yacute";
		case DKeyEvent::Key_thorn:
			return "Key_thorn";
		case DKeyEvent::Key_ydiaeresis:
			return "Key_ydiaeresis";
		case DKeyEvent::Key_unknown:
			return "Key_unknown";
    }
    return "Key_unknown";
}

/// @brief Converts a Key code name string to a Key code.
/// @param keyname - the Key code name string to convert.
/// @return an int representing the Key code.
int keyConverter::translateStringToKey( const string& keyname )
{                                                                         
    if (keyname == "Key_Escape")
        return DKeyEvent::Key_Escape;
    if (keyname == "Key_Tab")
        return DKeyEvent::Key_Tab;
    if (keyname == "Key_Backtab")
        return DKeyEvent::Key_Backtab;
    if (keyname == "Key_Backspace")
        return DKeyEvent::Key_Backspace;
    if (keyname == "Key_Return")
        return DKeyEvent::Key_Return;
    if (keyname == "Key_Enter")
        return DKeyEvent::Key_Enter;
    if (keyname == "Key_Insert")
        return DKeyEvent::Key_Insert;
    if (keyname == "Key_Delete")
        return DKeyEvent::Key_Delete;
    if (keyname == "Key_Pause")
        return DKeyEvent::Key_Pause;
    if (keyname == "Key_Print")
        return DKeyEvent::Key_Print;
    if (keyname == "Key_SysReq")
        return DKeyEvent::Key_SysReq;
    if (keyname == "Key_Home")
        return DKeyEvent::Key_Home;
    if (keyname == "Key_End")
        return DKeyEvent::Key_End;
    if (keyname == "Key_Left")
        return DKeyEvent::Key_Left;
    if (keyname == "Key_Up")
        return DKeyEvent::Key_Up;
    if (keyname == "Key_Right")
        return DKeyEvent::Key_Right;
    if (keyname == "Key_Down")
        return DKeyEvent::Key_Down;
    if (keyname == "Key_Prior")
        return DKeyEvent::Key_Prior;
    if (keyname == "Key_Next")
        return DKeyEvent::Key_Next;
    if (keyname == "Key_Shift")
        return DKeyEvent::Key_Shift;
    if (keyname == "Key_Control")
        return DKeyEvent::Key_Control;
    if (keyname == "Key_Meta")
        return DKeyEvent::Key_Meta;
    if (keyname == "Key_Alt")
        return DKeyEvent::Key_Alt;
    if (keyname == "Key_CapsLock")
        return DKeyEvent::Key_CapsLock;
    if (keyname == "Key_NumLock")
        return DKeyEvent::Key_NumLock;
    if (keyname == "Key_ScrollLock")
        return DKeyEvent::Key_ScrollLock;
    if (keyname == "Key_F1")
        return DKeyEvent::Key_F1;
    if (keyname == "Key_F2")
        return DKeyEvent::Key_F2;
    if (keyname == "Key_F3")
        return DKeyEvent::Key_F3;
    if (keyname == "Key_F4")
        return DKeyEvent::Key_F4;
    if (keyname == "Key_F5")
        return DKeyEvent::Key_F5;
    if (keyname == "Key_F6")
        return DKeyEvent::Key_F6;
    if (keyname == "Key_F7")
        return DKeyEvent::Key_F7;
    if (keyname == "Key_F8")
        return DKeyEvent::Key_F8;
    if (keyname == "Key_F9")
        return DKeyEvent::Key_F9;
    if (keyname == "Key_F10")
        return DKeyEvent::Key_F10;
    if (keyname == "Key_F11")
        return DKeyEvent::Key_F11;
    if (keyname == "Key_F12")
        return DKeyEvent::Key_F12;
    if (keyname == "Key_F13")
        return DKeyEvent::Key_F13;
    if (keyname == "Key_F14")
        return DKeyEvent::Key_F14;
    if (keyname == "Key_F15")
        return DKeyEvent::Key_F15;
    if (keyname == "Key_F16")
        return DKeyEvent::Key_F16;
    if (keyname == "Key_F17")
        return DKeyEvent::Key_F17;
    if (keyname == "Key_F18")
        return DKeyEvent::Key_F18;
    if (keyname == "Key_F19")
        return DKeyEvent::Key_F19;
    if (keyname == "Key_F20")
        return DKeyEvent::Key_F20;
    if (keyname == "Key_F21")
        return DKeyEvent::Key_F21;
    if (keyname == "Key_F22")
        return DKeyEvent::Key_F22;
    if (keyname == "Key_F23")
        return DKeyEvent::Key_F23;
    if (keyname == "Key_F24")
        return DKeyEvent::Key_F24;
    if (keyname == "Key_F25")
        return DKeyEvent::Key_F25;
    if (keyname == "Key_F26")
        return DKeyEvent::Key_F26;
    if (keyname == "Key_F27")
        return DKeyEvent::Key_F27;
    if (keyname == "Key_F28")
        return DKeyEvent::Key_F28;
    if (keyname == "Key_F29")
        return DKeyEvent::Key_F29;
    if (keyname == "Key_F30")
        return DKeyEvent::Key_F30;
    if (keyname == "Key_F31")
        return DKeyEvent::Key_F31;
    if (keyname == "Key_F32")
        return DKeyEvent::Key_F32;
    if (keyname == "Key_F33")
        return DKeyEvent::Key_F33;
    if (keyname == "Key_F34")
        return DKeyEvent::Key_F34;
    if (keyname == "Key_F35")
        return DKeyEvent::Key_F35;
    if (keyname == "Key_Super_L")
        return DKeyEvent::Key_Super_L;
    if (keyname == "Key_Super_R")
        return DKeyEvent::Key_Super_R;
    if (keyname == "Key_Menu")
        return DKeyEvent::Key_Menu;
    if (keyname == "Key_Hyper_L")
        return DKeyEvent::Key_Hyper_L;
    if (keyname == "Key_Hyper_R")
        return DKeyEvent::Key_Hyper_R;
    if (keyname == "Key_Help")
        return DKeyEvent::Key_Help;
    if (keyname == "Key_Direction_L")
        return DKeyEvent::Key_Direction_L;
    if (keyname == "Key_Direction_R")
        return DKeyEvent::Key_Direction_R;
    if (keyname == "Key_Space")
        return DKeyEvent::Key_Space;
    if (keyname == "Key_Any")
        return DKeyEvent::Key_Any;
    if (keyname == "Key_Exclam")
        return DKeyEvent::Key_Exclam;
    if (keyname == "Key_QuoteDbl")
        return DKeyEvent::Key_QuoteDbl;
    if (keyname == "Key_NumberSign")
        return DKeyEvent::Key_NumberSign;
    if (keyname == "Key_Dollar")
        return DKeyEvent::Key_Dollar;
    if (keyname == "Key_Percent")
        return DKeyEvent::Key_Percent;
    if (keyname == "Key_Ampersand")
        return DKeyEvent::Key_Ampersand;
    if (keyname == "Key_Apostrophe")
        return DKeyEvent::Key_Apostrophe;
    if (keyname == "Key_ParenLeft")
        return DKeyEvent::Key_ParenLeft;
    if (keyname == "Key_ParenRight")
        return DKeyEvent::Key_ParenRight;
    if (keyname == "Key_Asterisk")
        return DKeyEvent::Key_Asterisk;
    if (keyname == "Key_Plus")
        return DKeyEvent::Key_Plus;
    if (keyname == "Key_Comma")
        return DKeyEvent::Key_Comma;
    if (keyname == "Key_Minus")
        return DKeyEvent::Key_Minus;
    if (keyname == "Key_Period")
        return DKeyEvent::Key_Period;
    if (keyname == "Key_Slash")
        return DKeyEvent::Key_Slash;
    if (keyname == "Key_0")
        return DKeyEvent::Key_0;
    if (keyname == "Key_1")
        return DKeyEvent::Key_1;
    if (keyname == "Key_2")
        return DKeyEvent::Key_2;
    if (keyname == "Key_3")
        return DKeyEvent::Key_3;
    if (keyname == "Key_4")
        return DKeyEvent::Key_4;
    if (keyname == "Key_5")
        return DKeyEvent::Key_5;
    if (keyname == "Key_6")
        return DKeyEvent::Key_6;
    if (keyname == "Key_7")
        return DKeyEvent::Key_7;
    if (keyname == "Key_8")
        return DKeyEvent::Key_8;
    if (keyname == "Key_9")
        return DKeyEvent::Key_9;
    if (keyname == "Key_Colon")
        return DKeyEvent::Key_Colon;
    if (keyname == "Key_Semicolon")
        return DKeyEvent::Key_Semicolon;
    if (keyname == "Key_Less")
        return DKeyEvent::Key_Less;
    if (keyname == "Key_Equal")
        return DKeyEvent::Key_Equal;
    if (keyname == "Key_Greater")
        return DKeyEvent::Key_Greater;
    if (keyname == "Key_Question")
        return DKeyEvent::Key_Question;
    if (keyname == "Key_At")
        return DKeyEvent::Key_At;
    if (keyname == "Key_A")
        return DKeyEvent::Key_A;
    if (keyname == "Key_B")
        return DKeyEvent::Key_B;
    if (keyname == "Key_C")
        return DKeyEvent::Key_C;
    if (keyname == "Key_D")
        return DKeyEvent::Key_D;
    if (keyname == "Key_E")
        return DKeyEvent::Key_E;
    if (keyname == "Key_F")
        return DKeyEvent::Key_F;
    if (keyname == "Key_G")
        return DKeyEvent::Key_G;
    if (keyname == "Key_H")
        return DKeyEvent::Key_H;
    if (keyname == "Key_I")
        return DKeyEvent::Key_I;
    if (keyname == "Key_J")
        return DKeyEvent::Key_J;
    if (keyname == "Key_K")
        return DKeyEvent::Key_K;
    if (keyname == "Key_L")
        return DKeyEvent::Key_L;
    if (keyname == "Key_M")
        return DKeyEvent::Key_M;
    if (keyname == "Key_N")
        return DKeyEvent::Key_N;
    if (keyname == "Key_O")
        return DKeyEvent::Key_O;
    if (keyname == "Key_P")
        return DKeyEvent::Key_P;
    if (keyname == "Key_Q")
        return DKeyEvent::Key_Q;
    if (keyname == "Key_R")
        return DKeyEvent::Key_R;
    if (keyname == "Key_S")
        return DKeyEvent::Key_S;
    if (keyname == "Key_T")
        return DKeyEvent::Key_T;
    if (keyname == "Key_U")
        return DKeyEvent::Key_U;
    if (keyname == "Key_V")
        return DKeyEvent::Key_V;
    if (keyname == "Key_W")
        return DKeyEvent::Key_W;
    if (keyname == "Key_X")
        return DKeyEvent::Key_X;
    if (keyname == "Key_Y")
        return DKeyEvent::Key_Y;
    if (keyname == "Key_Z")
        return DKeyEvent::Key_Z;
    if (keyname == "Key_BracketLeft")
        return DKeyEvent::Key_BracketLeft;
    if (keyname == "Key_Backslash")
        return DKeyEvent::Key_Backslash;
    if (keyname == "Key_BracketRight")
        return DKeyEvent::Key_BracketRight;
    if (keyname == "Key_AsciiCircum")
        return DKeyEvent::Key_AsciiCircum;
    if (keyname == "Key_Underscore")
        return DKeyEvent::Key_Underscore;
    if (keyname == "Key_QuoteLeft")
        return DKeyEvent::Key_QuoteLeft;
    if (keyname == "Key_BraceLeft")
        return DKeyEvent::Key_BraceLeft;
    if (keyname == "Key_Bar")
        return DKeyEvent::Key_Bar;
    if (keyname == "Key_BraceRight")
        return DKeyEvent::Key_BraceRight;
    if (keyname == "Key_AsciiTilde")
        return DKeyEvent::Key_AsciiTilde;
    if (keyname == "Key_nobreakspace")
        return DKeyEvent::Key_nobreakspace;
    if (keyname == "Key_exclamdown")
        return DKeyEvent::Key_exclamdown;
    if (keyname == "Key_cent")
        return DKeyEvent::Key_cent;
    if (keyname == "Key_sterling")
        return DKeyEvent::Key_sterling;
    if (keyname == "Key_currency")
        return DKeyEvent::Key_currency;
    if (keyname == "Key_yen")
        return DKeyEvent::Key_yen;
    if (keyname == "Key_brokenbar")
        return DKeyEvent::Key_brokenbar;
    if (keyname == "Key_section")
        return DKeyEvent::Key_section;
    if (keyname == "Key_diaeresis")
        return DKeyEvent::Key_diaeresis;
    if (keyname == "Key_copyright")
        return DKeyEvent::Key_copyright;
    if (keyname == "Key_ordfeminine")
        return DKeyEvent::Key_ordfeminine;
    if (keyname == "Key_guillemotleft")
        return DKeyEvent::Key_guillemotleft;
    if (keyname == "Key_notsign")
        return DKeyEvent::Key_notsign;
    if (keyname == "Key_hyphen")
        return DKeyEvent::Key_hyphen;
    if (keyname == "Key_registered")
        return DKeyEvent::Key_registered;
    if (keyname == "Key_macron")
        return DKeyEvent::Key_macron;
    if (keyname == "Key_degree")
        return DKeyEvent::Key_degree;
    if (keyname == "Key_plusminus")
        return DKeyEvent::Key_plusminus;
    if (keyname == "Key_twosuperior")
        return DKeyEvent::Key_twosuperior;
    if (keyname == "Key_threesuperior")
        return DKeyEvent::Key_threesuperior;
    if (keyname == "Key_acute")
        return DKeyEvent::Key_acute;
    if (keyname == "Key_mu")
        return DKeyEvent::Key_mu;
    if (keyname == "Key_paragraph")
        return DKeyEvent::Key_paragraph;
    if (keyname == "Key_periodcentered")
        return DKeyEvent::Key_periodcentered;
    if (keyname == "Key_cedilla")
        return DKeyEvent::Key_cedilla;
    if (keyname == "Key_onesuperior")
        return DKeyEvent::Key_onesuperior;
    if (keyname == "Key_masculine")
        return DKeyEvent::Key_masculine;
    if (keyname == "Key_guillemotright")
        return DKeyEvent::Key_guillemotright;
    if (keyname == "Key_onequarter")
        return DKeyEvent::Key_onequarter;
    if (keyname == "Key_onehalf")
        return DKeyEvent::Key_onehalf;
    if (keyname == "Key_threequarters")
        return DKeyEvent::Key_threequarters;
    if (keyname == "Key_questiondown")
        return DKeyEvent::Key_questiondown;
    if (keyname == "Key_Agrave")
        return DKeyEvent::Key_Agrave;
    if (keyname == "Key_Aacute")
        return DKeyEvent::Key_Aacute;
    if (keyname == "Key_Acircumflex")
        return DKeyEvent::Key_Acircumflex;
    if (keyname == "Key_Atilde")
        return DKeyEvent::Key_Atilde;
    if (keyname == "Key_Adiaeresis")
        return DKeyEvent::Key_Adiaeresis;
    if (keyname == "Key_Aring")
        return DKeyEvent::Key_Aring;
    if (keyname == "Key_AE")
        return DKeyEvent::Key_AE;
    if (keyname == "Key_Ccedilla")
        return DKeyEvent::Key_Ccedilla;
    if (keyname == "Key_Egrave")
        return DKeyEvent::Key_Egrave;
    if (keyname == "Key_Eacute")
        return DKeyEvent::Key_Eacute;
    if (keyname == "Key_Ecircumflex")
        return DKeyEvent::Key_Ecircumflex;
    if (keyname == "Key_Ediaeresis")
        return DKeyEvent::Key_Ediaeresis;
    if (keyname == "Key_Igrave")
        return DKeyEvent::Key_Igrave;
    if (keyname == "Key_Iacute")
        return DKeyEvent::Key_Iacute;
    if (keyname == "Key_Icircumflex")
        return DKeyEvent::Key_Icircumflex;
    if (keyname == "Key_Idiaeresis")
        return DKeyEvent::Key_Idiaeresis;
    if (keyname == "Key_ETH")
        return DKeyEvent::Key_ETH;
    if (keyname == "Key_Ntilde")
        return DKeyEvent::Key_Ntilde;
    if (keyname == "Key_Ograve")
        return DKeyEvent::Key_Ograve;
    if (keyname == "Key_Oacute")
        return DKeyEvent::Key_Oacute;
    if (keyname == "Key_Ocircumflex")
        return DKeyEvent::Key_Ocircumflex;
    if (keyname == "Key_Otilde")
        return DKeyEvent::Key_Otilde;
    if (keyname == "Key_Odiaeresis")
        return DKeyEvent::Key_Odiaeresis;
    if (keyname == "Key_multiply")
        return DKeyEvent::Key_multiply;
    if (keyname == "Key_Ooblique")
        return DKeyEvent::Key_Ooblique;
    if (keyname == "Key_Ugrave")
        return DKeyEvent::Key_Ugrave;
    if (keyname == "Key_Uacute")
        return DKeyEvent::Key_Uacute;
    if (keyname == "Key_Ucircumflex")
        return DKeyEvent::Key_Ucircumflex;
    if (keyname == "Key_Udiaeresis")
        return DKeyEvent::Key_Udiaeresis;
    if (keyname == "Key_Yacute")
        return DKeyEvent::Key_Yacute;
    if (keyname == "Key_THORN")
        return DKeyEvent::Key_THORN;
    if (keyname == "Key_ssharp")
        return DKeyEvent::Key_ssharp;
    if (keyname == "Key_agrave")
        return DKeyEvent::Key_agrave;
    if (keyname == "Key_aacute")
        return DKeyEvent::Key_aacute;
    if (keyname == "Key_acircumflex")
        return DKeyEvent::Key_acircumflex;
    if (keyname == "Key_atilde")
        return DKeyEvent::Key_atilde;
    if (keyname == "Key_adiaeresis")
        return DKeyEvent::Key_adiaeresis;
    if (keyname == "Key_aring")
        return DKeyEvent::Key_aring;
    if (keyname == "Key_ae")
        return DKeyEvent::Key_ae;
    if (keyname == "Key_ccedilla")
        return DKeyEvent::Key_ccedilla;
    if (keyname == "Key_egrave")
        return DKeyEvent::Key_egrave;
    if (keyname == "Key_eacute")
        return DKeyEvent::Key_eacute;
    if (keyname == "Key_ecircumflex")
        return DKeyEvent::Key_ecircumflex;
    if (keyname == "Key_ediaeresis")
        return DKeyEvent::Key_ediaeresis;
    if (keyname == "Key_igrave")
        return DKeyEvent::Key_igrave;
    if (keyname == "Key_iacute")
        return DKeyEvent::Key_iacute;
    if (keyname == "Key_icircumflex")
        return DKeyEvent::Key_icircumflex;
    if (keyname == "Key_idiaeresis")
        return DKeyEvent::Key_idiaeresis;
    if (keyname == "Key_eth")
        return DKeyEvent::Key_eth;
    if (keyname == "Key_ntilde")
        return DKeyEvent::Key_ntilde;
    if (keyname == "Key_ograve")
        return DKeyEvent::Key_ograve;
    if (keyname == "Key_oacute")
        return DKeyEvent::Key_oacute;
    if (keyname == "Key_ocircumflex")
        return DKeyEvent::Key_ocircumflex;
    if (keyname == "Key_otilde")
        return DKeyEvent::Key_otilde;
    if (keyname == "Key_odiaeresis")
        return DKeyEvent::Key_odiaeresis;
    if (keyname == "Key_division")
        return DKeyEvent::Key_division;
    if (keyname == "Key_oslash")
        return DKeyEvent::Key_oslash;
    if (keyname == "Key_ugrave")
        return DKeyEvent::Key_ugrave;
    if (keyname == "Key_uacute")
        return DKeyEvent::Key_uacute;
    if (keyname == "Key_ucircumflex")
        return DKeyEvent::Key_ucircumflex;
    if (keyname == "Key_udiaeresis")
        return DKeyEvent::Key_udiaeresis;
    if (keyname == "Key_yacute")
        return DKeyEvent::Key_yacute;
    if (keyname == "Key_thorn")
        return DKeyEvent::Key_thorn;
    if (keyname == "Key_ydiaeresis")
        return DKeyEvent::Key_ydiaeresis;
    if (keyname == "Key_unknown")
        return DKeyEvent::Key_unknown;
    return DKeyEvent::Key_unknown;
}
