//============================================================================
// keyConverter.h - converts keyboard key string to/from DKeyEvent::Key enum
// value names
//
// Created 6/9/03 By Patrick Shinpaugh
//=============================================================================
#ifndef _KEYCONVERTER_H_
#define _KEYCONVERTER_H_
#include <eventmgr/devents.h>
#include <string>

#ifdef WIN32
#ifdef EVENTMGR_EXPORTS
#define EVENTMGR_API __declspec(dllexport)
#else
#define EVENTMGR_API __declspec(dllimport)
#endif /* EVENTMGR_EXPORTS */
#else
#define EVENTMGR_API
#endif /* WIN32 */

using namespace std;

//=============================================================================
/// @class keyConverter
/// @brief Converts Key code name strings to key codes and Key codes to key code
/// name strings.
///
/// The Key code name strings are the same as the enum name defined as enum Key
/// in the DKeyEvent class.
//=============================================================================
class EVENTMGR_API keyConverter
{
    public:
        static string translateKeyToString( int keycode );
        static int translateStringToKey( const string& keyname );

    private:
		/// @brief Constructor.
        keyConverter() {};
};

#endif
