#ifndef _DGLFONT_H_
#define _DGLFONT_H_
#ifdef WIN32
#else
#include <X11/Intrinsic.h>
#endif /* WIN32 */

#ifdef WIN32
#ifdef FONTMGR_EXPORTS
#define FONTMANAGER_API __declspec(dllexport)
#else
#define FONTMANAGER_API __declspec(dllimport)
#endif /* FONTMGR_EXPORTS */
#else
#define FONTMANAGER_API
#endif

//=============================================================================
/// @class dglfont 
/// @author Patrick Shinpaugh
/// @brief Dglfont is used for the generation OpenGL display lists of font bitmaps
//=============================================================================
class FONTMANAGER_API dglfont
{
    public:
#ifdef WIN32
		dglfont( HDC hDC, int stockfont, unsigned char start = 0, unsigned char count = 255 );
#else
        dglfont( Display* dpy, char* fontname, unsigned char start = 0, unsigned char count = 255 );
#endif /* WIN32 */
        ~dglfont();

        unsigned char getSize() { return m_count; };
        char* getFontName() { return m_fontname; };
        void dglPrint( const char* output );
        void dglPrintPos( const char* output, int x, int y, int z = 0 );
        void dglPrintPos( const char* output, float x, float y, float z = 0.0f );
        int width() { return m_columnwidth; };
        int height() { return m_rowheight; };

    private:
#ifdef WIN32
		int m_stockfont;
		HGDIOBJ m_hfont;
#else
        XFontStruct* m_xfont;
#endif /* WIN32 */
        char* m_fontname;
        int m_columnwidth;
        int m_rowheight;
        unsigned int m_fontbase;
        unsigned char m_start;
        unsigned char m_count;
};

#endif
