#ifndef _MESSAGEMANAGER_H_
#define _MESSAGEMANAGER_H_
#define DEFAULT_MMPORT 8000
#include<string>
#include<pexpr/PostOffice.h>
#include<pexpr/POBox.h>
#include<pexpr/POTextMsg.h>
#include<pexpr/POAddress.h>
using namespace std;

#ifdef WIN32
#ifdef MSGMGR_EXPORTS
#define MSGMGR_API __declspec(dllexport)
#else
#define MSGMGR_API __declspec(dllimport)
#endif /* MSGMGR_EXPORTS */
#else
#define MSGMGR_API
#endif /* WIN32 */

class POBox;
//class PostOffice;

//=============================================================================
/// @class MessageManager
/// @author Daniel Larimer
/// @brief Provides a global interface to ponyexpress, encapsulates Qt.
//=============================================================================
class MSGMGR_API MessageManager
{
    public:
        static void      init();
        static void      setupRegistry( const string& cfg = "diverse.xml" );
        static string    connectTo( const string& adr, 
                                    int port = DEFAULT_MMPORT );
        static bool      servicePort( int port );
        static bool      closePort( int port );
        static POBox*    registerPOBox( const string& boxname );
        static bool      closePOBox( const string& boxname );

    private:
        MessageManager();

        static PostOffice*      m_po;
        static bool             m_setup;

};

#endif
