//=============================================================================
// POErrorMsg.h
//
// Created 5/13/03 By Daniel Larimer
//=============================================================================
#ifndef _POERRORMSG_H_
#define _POERRORMSG_H_
#include<pexpr/POMessage.h>
#include<string>
using namespace std;


//=============================================================================
/// @class POErrorMsg
/// @brief A simple text message.
//=============================================================================
class PEXPR_API POErrorMsg : public POMessage
{
    public:
        POErrorMsg( const string& txt = "");
        POErrorMsg( const POErrorMsg& cpy );
        virtual ~POErrorMsg();
		/// @brief Get the typ eof message.
		/// @return a string containing the type of message.
        virtual string messageType()const { return "POErrorMsg"; };

		/// @brief Get the text of the message.
		/// @return a string containing the message text.
        string  getText()const{ return m_txt.val(); }
        void    setText( const string& txt );

        virtual POMessage* clone()const;

        //==========================
        // Packable
        //==========================
        int packsize()const;
        int pack( char* buf )const;
        int unpack( char* buf );

    private:
        POString  m_txt;
};

#endif
