//=============================================================================
// POMessage.h
//
// Created 5/13/03 By Daniel Larimer
//=============================================================================
#ifndef _POMESSAGE_H_
#define _POMESSAGE_H_
#include<pexpr/Packable.h>
#include<pexpr/POAddress.h>
#include<pexpr/POTypes.h>
#include<string>
using namespace std;


//=============================================================================
/// @class POMessage POMessage.h
/// @brief The base class for all messages sent through the PostOffice
//=============================================================================
class PEXPR_API POMessage : impliments Packable
{
    public:
        POMessage();
        POMessage( const POMessage& cpy );
        virtual ~POMessage();
        virtual string messageType()const { return "POMessage"; };

        void setSource( const POAddress& source );
        void setDestination( const POAddress& dest );

        POAddress getSource()const;
        POAddress getDestination()const;
        string    getPackedType()const{ return m_derivedtype.val(); }

        virtual POMessage* clone()const;

        //==========================
        // Packable
        //==========================
        int packsize()const;
        int pack( char* buffer )const;
        int unpack( char* buffer );

    private:
        POAddress m_source;
        POAddress m_destination;
        POString  m_derivedtype;
};
#include<pexpr/POMessageFactory.h>
#endif
