#ifndef _POMESSAGEFACTORY_H_
#define _POMESSAGEFACTORY_H_
#include<string>
#include<map>
#include<pexpr/POMessage.h>
using namespace std;


//=============================================================================
/// @class POMessageFactory
/// @brief Builds POMessage objects from messages.
//=============================================================================
class PEXPR_API POMessageFactory
{
    public:
        static void init();
        static bool Register( POMessage* msg );
        static bool UnRegister( const string& type );

        static POMessage* BuildFromBuffer( char* buffer );
        static POMessage* Build( const string& type );

    private:
        static map<string, POMessage*>  *m_messages;
        static bool                      m_init;
};

//=============================================================================
/// @class RegisterMessage
/// @brief A template which maintains message structures for message registration.
//=============================================================================
template<class msgtype>
class PEXPR_API RegisterMessage
{
    public:
		/// @brief Constructor.
		RegisterMessage()
		{   
			msg = new msgtype();
			if( !POMessageFactory::Register( msg ) )
			delete msg;
			msg = NULL;
		}
		/// @brief Destructor.
		~RegisterMessage()
		{
//			if( msg );
//			POMessageFactory::UnRegister( msg->MessageType() );
		}
		msgtype* msg;
};

#endif
