#include"POServer.h"
#include"POClient.h"

//=============================================================================
/// @brief Constructor.
/// @param address - a QHostAddress object containing the address information of
/// the server.
/// @param port - the port to connect to.
/// @param backlog - the backlog.
//=============================================================================
POServer::POServer( const QHostAddress& address, int port, int backlog )
:QServerSocket( port, backlog )
{
}

//=============================================================================
/// @brief Create a new client connection through the specified socket.
/// @param socket - the socket for which the client will be created.
//=============================================================================
void POServer::newConnection( int socket )
{
    emit newClient( new POClient( socket ) );
}
