//=============================================================================
// POServer.h
//
// Created 5/13/03 By Daniel Larimer
//=============================================================================
#ifndef _POSERVER_H_
#define _POSERVER_H_
#include<qserversocket.h>

#ifdef WIN32
#include <windows.h>
#ifdef PEXPR_EXPORTS
#define PEXPR_API __declspec(dllexport)
#else
#define PEXPR_API __declspec(dllimport)
#endif /* PEXPR_EXPORTS */
#else
#define PEXPR_API
#endif /* WIN32 */

class POClient;

//=============================================================================
/// @class POServer
/// @brief The server which handles client connections.
//=============================================================================
class PEXPR_API POServer : public QServerSocket
{
    Q_OBJECT
    public:
        POServer( const QHostAddress& address, int port, int backlog = 1 );
		/// @brief Destructor.
        virtual ~POServer(){};
    
        void newConnection( int socket );
        
    signals:
        void newClient( POClient* );
};

#endif
