//=============================================================================
// POTextMsg.h
//
// Created 5/13/03 By Daniel Larimer
//=============================================================================
#ifndef _POTEXTMSG_H_
#define _POTEXTMSG_H_
#include<pexpr/POMessage.h>
#include<string>
using namespace std;


//=============================================================================
/// @class POTextMsg POTextMsg.h
/// @brief A simple text message
//=============================================================================
class PEXPR_API POTextMsg : public POMessage
{
    public:
        POTextMsg( const string& txt = "");
        POTextMsg( const POTextMsg& cpy );
        virtual ~POTextMsg();
		/// @brief Get the message type.
		/// @return a string containing the type of message.
        virtual string messageType()const { return "POTextMsg"; };

		/// @brief Get the text of the message.
		/// @return a string containing the text of the message.
        string  getText()const{ return m_txt.val(); }
        void    setText( const string& txt );

        virtual POMessage* clone()const;

        //==========================
        // Packable
        //==========================
        int packsize()const;
        int pack( char* buf )const;
        int unpack( char* buf );

    private:
        POString  m_txt;
};

#endif
