#ifndef _PACKABLE_H_
#define _PACKABLE_H_

// Define this so we can be like Java
// it also makes derived classes more readable
#define impliments public


#ifdef WIN32
#include <windows.h>
#ifdef PEXPR_EXPORTS
#define PEXPR_API __declspec(dllexport)
#else
#define PEXPR_API __declspec(dllimport)
#endif /* PEXPR_EXPORTS */
#else
#define PEXPR_API
#endif /* WIN32 */

//=============================================================================
/// @class Packable
/// @brief An interface for all packable classes.
//=============================================================================
class PEXPR_API Packable
{
    public:
        virtual int packsize()const = 0;
        virtual int pack( char* buf )const = 0;
        virtual int unpack( char* buf ) = 0;
};

#endif

