#ifndef _BYTESWAP_H_
#define _BYTESWAP_H_

void byteswap( void* d, int size );
/// converts standard byte order to the host format
/// \return true - if swap was needed
bool std2host( void* d, int size )
{
    #ifdef WIN32
        byteswap( d, size );
        return true;
    #endif
    #ifdef _LINUX_
        byteswap( d, size );
        return true;
    #endif
    return false;
}

/// converts the host byte order to the standard order
/// \return true if swap was needed
bool host2std( void* d, int size )
{
    #ifdef WIN32
        byteswap( d, size );
        return true;
    #endif
    #ifdef _LINUX_
        byteswap( d, size );
        return true;
    #endif
    // Mac OS X & IRIX are in the standard format
    return false;
}

void swap( char& a, char& b)
{
    if( &a == &b ) return;
    char tmp = a;
    a = b;
    b = tmp;
}
void byteswap( void* d, int size )
{
    char* data = (char*)d;
    int tmp = 0;
    int hsize = size / 2;
    while( tmp < hsize )
    {
        swap( data[tmp], data[size-tmp-1] );
        tmp++;
    }
}


#endif
