#include"BoxMonitor.h"
#include<qlistview.h>
#include<qlayout.h>
#include<pexpr/POBox.h>
#include<qlabel.h>
#include<pexpr/POMessage.h>
#if ( QT_VERSION < 300 )
#include "qt23wrappers.h"
#endif

BoxMonitor::BoxMonitor( QWidget* parent, POBox* po )
:QHGroupBox( parent )
{
    m_po = po;

    cout<<"BoxMonitor: po = "<<(int)po;
    if( po )
    {
        setTitle( tr(po->getName().c_str())) ;
        connect( m_po, SIGNAL( messageSent( const POMessage* ) ),
                 this, SLOT( sentMessage( const POMessage* ) ) );
        connect( m_po, SIGNAL( messageArrived( const POMessage* ) ),
                 this, SLOT( gotMessage( const POMessage* ) ) );
                 
    }
    else
    {
        setTitle( "Not Selected" ) ;
    }
    
    QWidget* container = new QWidget( this ); 
    QGridLayout* glayout = new QGridLayout( container, 2, 2 );
    glayout->addWidget( new QLabel( "Incomming Messages", container ), 0, 0 );
    glayout->addWidget( new QLabel( "Sent Messages", container ), 0, 1, AlignRight );

    m_inbox = new QListView( container );
    m_inbox->addColumn( "Type" );
    m_inbox->addColumn( "From" );
    m_sentbox = new QListView( container );
    m_sentbox->addColumn( "Type" );
    m_sentbox->addColumn( "To" );

    glayout->addWidget( m_inbox, 1, 0 );
    glayout->addWidget( m_sentbox, 1, 1 );
}

void BoxMonitor::gotMessage( const POMessage* msg )
{
    m_inbox->insertItem( new QListViewItem( m_inbox, msg->messageType().c_str(),
                                                     msg->getSource().toString().c_str() ) );

    if( m_inbox->childCount() > 150 )
#if ( QT_VERSION < 300 )
		delete lastItem( m_inbox );
#else
        delete m_inbox->lastItem();
#endif
}

void BoxMonitor::sentMessage( const POMessage* msg )
{
    m_sentbox->insertItem( new QListViewItem( m_inbox, msg->messageType().c_str(),
                                                     msg->getDestination().toString().c_str() ) );
    if( m_sentbox->childCount() > 150 )
#if ( QT_VERSION < 300 )
		delete lastItem( m_sentbox );
#else
        delete m_sentbox->lastItem();
#endif
}
