//=============================================================================
/// @class CommandWidget
/// @brief Interfaces with the Command Manager to issue commands
/// @author Daniel Larimer
//=============================================================================
#ifndef _COMMANDWIDGET_H_
#define _COMMANDWIDGET_H_
#include <qglobal.h>
#if ( QT_VERSION < 300 )
#include"CommandWidget23/CommandWidget.h"
#else
#include<qtextedit.h>
#include<commander/Commander.h>

#ifdef WIN32
#ifdef QTUTIL_EXPORTS
#define QTUTIL_API __declspec(dllexport)
#else
#define QTUTIL_API __declspec(dllimport)
#endif /* QTUTIL_EXPORTS */
#else
#define QTUTIL_API
#endif /* WIN32 */

class QTUTIL_API CommandWidget : public QTextEdit
{
    Q_OBJECT
    public:
        CommandWidget( Commander *cmdr, QWidget* parent );

    public slots:
        void sendCommand();
    protected:
        void keyPressEvent( QKeyEvent* e );

    private:
        Commander*       m_commander;
        vector<string>   m_history;
        int              m_historyindex;
        string           m_current;
        bool             m_firsttab;
        QString          m_prompt;
        QString          m_prompttxt;
};
#endif /* ( QT_VERSION < 300 ) */

#endif
