#ifndef _COMMANDWIDGET23_H_
#define _COMMANDWIDGET23_H_
#if ( QT_VERSION < 300 )
#include <qmultilineedit.h>
#include<commander/Commander.h>

#ifdef WIN32
#ifdef QTUTIL_EXPORTS
#define QTUTIL_API __declspec(dllexport)
#else
#define QTUTIL_API __declspec(dllimport)
#endif /* QTUTIL_EXPORTS */
#else
#define QTUTIL_API
#endif /* WIN32 */

//=============================================================================
// Provides an command line interface for use with DIVERSe.
//=============================================================================
class QTUTIL_API CommandWidget : public QMultiLineEdit
{
    Q_OBJECT
    public:
        CommandWidget( Commander *cmdr, QWidget* parent );

    public slots:
        void sendCommand();
    protected:
        void keyPressEvent( QKeyEvent* e );

    private:
        Commander*       m_commander;
        vector<string>   m_history;
        int              m_historyindex;
        string           m_current;
        bool             m_firsttab;
        QString          m_prompt;
        QString          m_prompttxt;
		int              m_line;
		int              m_column;
};
#endif /* QT_VERSION < 300 */


#endif
