//=============================================
// EventMonitorDialog.cpp
// Author: Patrick Shinpaugh
// Date: July 1, 2003
//=============================================
#include<dmath/dmath.h>
#include "EventMonitorDialog.h"
#include <tracer/Tracer.h>
#include <qlayout.h>

EventMonitorDialog* EventMonitorDialog::m_dialog = NULL;

EventMonitorDialog::EventMonitorDialog( QWidget* parent )
    :QDialog( parent, 0, false, Qt::WDestructiveClose )
{
    m_widget = new EventMonitorWidget( this );
	connect( m_widget, SIGNAL( widgetClosed() ), this, SLOT( close() ) );
    this->setCaption( "EventMonitor" );
    this->show();
    Tracer::debug( "EventMonitorDialog constructor completed" );
}

EventMonitorDialog::~EventMonitorDialog()
{
    if ( m_widget )
        delete m_widget;
    Tracer::debug( "EventMonitorDialog destroyed" );
}

void EventMonitorDialog::open( QWidget* parent )
{
    m_dialog = new EventMonitorDialog( parent );
    Tracer::debug( "EventMonitor opened" );
}
