#ifndef _POMONITOR_H_
#define _POMONITOR_H_
#include<qwidget.h>
#include<map>
#include<string>

#ifdef WIN32
#ifdef QTUTIL_EXPORTS
#define QTUTIL_API __declspec(dllexport)
#else
#define QTUTIL_API __declspec(dllimport)
#endif /* QTUTIL_EXPORTS */
#else
#define QTUTIL_API
#endif /* WIN32 */

using namespace std;

class POBox;
class QListView;
class BoxMonitor;
class QListViewItem;
class QWidgetStack;
class POStatus;

//=============================================================================
// @class POMonitor
// @brief Monitors connections and message traffic
//=============================================================================
class QTUTIL_API POMonitor : public QWidget
{
    Q_OBJECT
    public:
        POMonitor( QWidget* parent );


    public slots:
        void addPostOffice( const string& po );
        void addClient( const string& po, const string& client );
        void addPOBox( const string& po, const string& client, const string& box );
        void addPOBox( const string& po, const string& box );
        void removeClient( const string& po, const string& client );
        void removePOBox( const string& po, const string& box );
        void removePOBox( const string& po, const string& client, const string& box );

        void itemClicked( QListViewItem* item );
        
    signals:
        void boxSelected( POBox* box );

    private:
        QListViewItem* findItemIn( QListViewItem* item, const string& txt, int col );
        QListView* m_listview;

        map<POBox*, BoxMonitor*>  m_boxes; 
        QWidgetStack* m_boxstack;
        QWidgetStack* m_postack;

        POStatus*     m_defaultpostat;
        BoxMonitor*   m_defaultboxmon;
};

#endif
