#include"PanelRegistry.h"
#include"PrefMgrPanel.h"
#include<pluginmgr/PluginManager.h>
#include<dutil/ColonList.h>
#include<dreg/Registry.h>
#include<diverseconfig.h>
#include<tracer/Tracer.h>
#include<qdir.h>

vector<PanelWidget*> PanelRegistry::m_panels;
bool                 PanelRegistry::m_initialized = false;

//=============================================================================
/// @brief Initializes the PanelRegistry.
//=============================================================================
void PanelRegistry::init()
{
    if( m_initialized ) return;
    m_initialized = true;
    registerPanel( new PrefMgrPanel( NULL ) );
    //====================================
    // Load all panels in the panel path
    //====================================
    string PPath = string(INSTALLDIR) + "/panels";
    string path = Registry::getValue( "PreferenceManager/panelpath", 
                                       PPath);
    ColonList clist(path);
    vector<string> dlist = clist.getList();
    for( unsigned int i = 0; i < dlist.size(); i++ )
    {
        PluginManager::addSearchDirectory( dlist[i] );
        QDir dir( dlist[i].c_str(), "*.plug" );
        for( unsigned int i = 0; i < dir.count(); i++ )
        {
            string pname( dir[i].latin1() );
            Tracer::debug( "Loading Panel: %s", 
                            dir.absFilePath( dir[i] ).latin1() );
            pname = pname.substr( 0, pname.size() - 5 );
            PluginManager::loadPlugin( pname );
        }
    }
    
}

//=============================================================================
/// @brief Register a panel with the PanelRegistry.
/// @param pw - a pointer the panel widget to register.
//=============================================================================
void PanelRegistry::registerPanel( PanelWidget* pw )
{
    m_panels.push_back( pw );
}
