#ifndef _PANELREGISTRY_H_
#define _PANELREGISTRY_H_
#include<vector>
using namespace std;

#ifdef WIN32
#ifdef QTUTIL_EXPORTS
#define QTUTIL_API __declspec(dllexport)
#else
#define QTUTIL_API __declspec(dllimport)
#endif /* QTUTIL_EXPORTS */
#else
#define QTUTIL_API
#endif /* WIN32 */

class PanelWidget;

//=============================================================================
/// @class PanelRegistry
/// @author Daniel Larimer
/// @brief Provides a place for Preference Panel Plugins to register themselves.
//=============================================================================
class QTUTIL_API PanelRegistry
{
    public:
        static void init();
        static void registerPanel( PanelWidget* pw );
       
        static vector<PanelWidget*>& getPanels() { return m_panels; }
    private:
        static vector<PanelWidget*> m_panels;
        static bool                 m_initialized;
};

#endif
