#include"PanelWidget.h"
#include<string>
using namespace std;

//=============================================================================
/// @brief Constructor.
/// @param parent - the parent QWidget.
/// @param listname - the unique name of the panel.
//=============================================================================
PanelWidget::PanelWidget( QWidget* parent, const string& listname )
:QWidget( parent, listname.c_str() )
{
    m_listname = listname;
}

//=============================================================================
/// @brief Get the list name for the panel.
/// @return a string containing the list name of the panel.
//=============================================================================
string PanelWidget::getListName()const
{
    return m_listname;
}

//=============================================================================
/// @brief Set the list name of the panel.
/// @param listname - the unique name of the panel.
//=============================================================================
void PanelWidget::setListName( const string& listname )
{
    m_listname = listname;
}
