#ifndef _PANELWIDGET_H_
#define _PANELWIDGET_H_
#include<qwidget.h>
#include<qlistview.h>
#include<string>

#ifdef WIN32
#ifdef QTUTIL_EXPORTS
#define QTUTIL_API __declspec(dllexport)
#else
#define QTUTIL_API __declspec(dllimport)
#endif /* QTUTIL_EXPORTS */
#else
#define QTUTIL_API
#endif /* WIN32 */

using namespace std;

//=============================================================================
/// @class PanelWidget
/// @author Daniel Larimer
/// @brief Base class for all preference pane widgets.
///
/// All preference panels should be derived from this class. The listname should
/// be unique among all of the available panels or there could be conflicts.
//=============================================================================
class QTUTIL_API PanelWidget : public QWidget
{
    Q_OBJECT
    public:
        PanelWidget( QWidget* parent, const string& listname="unnamed" );

        virtual PanelWidget* clone( QWidget* parent = NULL )const = 0;
        string               getListName()const;

    public slots:
        void setListName( const string& name );
            
    private:
        string m_listname;
};

#endif
