#ifndef _PATHEDITWIDGET_H_
#define _PATHEDITWIDGET_H_
#include<qwidget.h>
#include<qstring.h>
#include<dutil/ColonList.h>

#ifdef WIN32
#ifdef QTUTIL_EXPORTS
#define QTUTIL_API __declspec(dllexport)
#else
#define QTUTIL_API __declspec(dllimport)
#endif /* QTUTIL_EXPORTS */
#else
#define QTUTIL_API
#endif /* WIN32 */

class QListBox;
class QLabel;

//=============================================================================
// @class PathEditWidget
// @brief Manages the preferences for the pref manager itself, ie: where
//        to load panes.  It also serves as an example of how to create a
//        panel
//=============================================================================
class QTUTIL_API PathEditWidget : public QWidget
{
    Q_OBJECT
    public:
        PathEditWidget( QWidget* parent );
    
        void   setPath( const string& path );
        string getPath()const;
        ColonList getPathList()const;

    public slots:
        void setLabel( const QString& label );
        void removeSelectedPath();
        void addPath( const QString& path );
        void selectPath();

    signals:
        void pathChanged( const string& );
        void directoryAdded( const string& );
        void directoryRemoved( const string& );
     
    private:
        QListBox*   m_panelpathlist;
        QLabel*     m_label;
        ColonList   m_pathlist;
};


#endif
