#include"PreferenceManager.h"
#include"PanelWidget.h"
#include"PanelRegistry.h"
#include<qlistview.h>
#include<qwidgetstack.h>
#include<qpushbutton.h>
#include<dreg/Registry.h>
#include<qlayout.h>

PreferenceManager::PreferenceManager( QWidget* parent )
:QWidget( parent )
{
    QGridLayout* m_layout = new QGridLayout( this );
    m_panellist = new QListView( this );
    m_panellist->setMaximumWidth( 200 );
    m_panellist->setMinimumWidth( 150 );
    m_panelstack = new QWidgetStack( this );
    m_panelstack->setMinimumWidth( 500 );
    m_save = new QPushButton("Save", this );
    m_save->setMaximumSize( QSize(150, 30) );
    connect( m_save, SIGNAL( clicked() ), this, SLOT( saveRegistry() ) );
    m_default = new QWidget(this);
    m_panelstack->addWidget( m_default, 0 );
    m_layout->addMultiCellWidget( m_panellist, 0, 1, 0, 0, AlignLeft  );
    m_layout->addWidget( m_panelstack, 0, 1, AlignLeft );
    m_layout->addWidget( m_save, 1, 1, AlignRight );

    m_panellist->addColumn( "Category", 150);

    connect( m_panellist, SIGNAL( selectionChanged( QListViewItem* ) ),
             this,        SLOT  ( selectionChanged( QListViewItem* ) ) );
    
    PanelRegistry::init();
    vector<PanelWidget*> panels = PanelRegistry::getPanels(); 
    
    for( unsigned int i = 0; i < panels.size(); i++ )
    {
        PanelWidget* wid = panels[i]->clone();
        QListViewItem* item = new QListViewItem( m_panellist, wid->getListName().c_str() );
        m_itemmap[item] = wid;
#if (QT_VERSION < 300)
        m_panelstack->addWidget( wid, 0 );
#else
        m_panelstack->addWidget( wid );
#endif
    }
}

void PreferenceManager::saveRegistry()
{
    Registry::save();
}

void PreferenceManager::selectionChanged( QListViewItem* item )
{
    m_panelstack->raiseWidget( m_itemmap[item] );
}
