#ifndef _PREFERENCEMANAGER_H_
#define _PREFERENCEMANAGER_H_
#include<qwidget.h>
#include<map>
using namespace std;

#ifdef WIN32
#ifdef QTUTIL_EXPORTS
#define QTUTIL_API __declspec(dllexport)
#else
#define QTUTIL_API __declspec(dllimport)
#endif /* QTUTIL_EXPORTS */
#else
#define QTUTIL_API
#endif /* WIN32 */

class QListView;
class QWidgetStack;
class QListViewItem;
class PanelWidget;
class QPushButton;

//=============================================================================
/// @class PreferenceManager
/// @author Daniel Larimer
/// @brief Provides a container for hooking in custom preference panes 
//=============================================================================
class QTUTIL_API PreferenceManager : public QWidget
{
    Q_OBJECT
    public:
        PreferenceManager( QWidget* parent );
    public slots:
        void selectionChanged( QListViewItem* );
        void saveRegistry();
        
    private:
        QPushButton*                      m_save;
        QPushButton*                      m_saveas;
        QListView*                        m_panellist;
        QWidgetStack*                     m_panelstack;
        map<QListViewItem*, PanelWidget*> m_itemmap;
        QWidget*                          m_default;
};

#endif
