#ifndef _QDGLVIEWPORT_H_
#define _QDGLVIEWPORT_H_
#include<dmath/dmath.h>
#include<qgl.h>
#include<displaymgr/DViewport.h>
#include<string>
using namespace std;
class QMouseEvent;

#ifdef WIN32
#ifdef QTUTIL_EXPORTS
#define QTUTIL_API __declspec(dllexport)
#else
#define QTUTIL_API __declspec(dllimport)
#endif /* QTUTIL_EXPORTS */
#else
#define QTUTIL_API
#endif /* WIN32 */

//=============================================================================
/// @class QDWidget 
/// @author Daniel Larimer
/// @brief A widget that displays the current DGL scene.
///============================================================================
class QTUTIL_API QDWidget : public QGLWidget
{
    Q_OBJECT
    public: 
        QDWidget( QWidget* parent );

        void paintGL();
        void resizeGL( int width, int height );
        void initializeGL(){};

        int getFrameNumber()const { return m_framenum; }

    public slots:
        /// Setup perspective and call DisplayManager::Draw()
        virtual void frame(){ updateGL(); };


    protected:
        void mousePressEvent( QMouseEvent* evt );
        void mouseReleaseEvent( QMouseEvent* evt );
        void mouseMoveEvent( QMouseEvent* evt );
        void keyPressEvent( QKeyEvent* evt );
        void keyReleaseEvent( QKeyEvent* evt );

    private:
        int   m_displayid;
        int   m_framenum;
        float m_left;
        float m_right;
        float m_bottom;
        float m_top;
        float m_fov;
        string m_headtracker_name;
};

#endif
