#ifndef _DGLWINDOW_H_
#define _DGLWINDOW_H_
#include"qmainwindow.h"
#include <dmath/Rect.h>
#include <string>
using namespace std;
#include<dutil/DTime.h>
class QDWidget;
class QPopupMenu;

#ifdef WIN32
#ifdef QTUTIL_EXPORTS
#define QTUTIL_API __declspec(dllexport)
#else
#define QTUTIL_API __declspec(dllimport)
#endif /* QTUTIL_EXPORTS */
#else
#define QTUTIL_API
#endif /* WIN32 */

//=============================================================================
/// @class QDWindow
/// @brief Provides a Qt window to display graphical output and provides GUI
/// interface to configuration and interactive tools.
//=============================================================================
class QTUTIL_API QDWindow : public QMainWindow 
{
    Q_OBJECT
    public:
        QDWindow();
        
    public slots:
        void frame();
        void quit();
        void editPrefs();
        void showCommandLine();
        void eventMonitor();
        void messageMonitor();
        void caveDeviceSimulator();
        void toggleGnomonOverlay();
        void toggleDebugOverlay();
        void calcfps();
    
    private:
        QDWidget*     m_dwidget;
        int           m_lastframe;
        int           m_fcount;
        int           m_debugol;
        int           m_gnomonol;
        QPopupMenu*   m_overlays;
        DTime         m_etime;
};

#endif
