//=============================================
// EventMonitorPlugin.cpp
// Author: Patrick Shinpaugh
// Date: July 3, 2003
//=============================================
#include<dmath/dmath.h>
#include "caveDeviceSimulatorDialog.h"
#include <tracer/Tracer.h>

caveDeviceSimulatorDialog* caveDeviceSimulatorDialog::m_dialog = NULL;

caveDeviceSimulatorDialog::caveDeviceSimulatorDialog( QWidget* parent )
    :QDialog( parent, 0, false, Qt::WDestructiveClose )
{
    m_widget = new caveDeviceSimulatorWidget( this );
    connect( m_widget, SIGNAL( widgetClosed() ), this, SLOT( close() ) );
    this->setCaption( "caveDeviceSimulator" );
    this->show();
    Tracer::debug( "caveDeviceSimulatorDialog constructor completed" );
}

caveDeviceSimulatorDialog::~caveDeviceSimulatorDialog()
{
    if ( m_widget )
        delete m_widget;
    Tracer::debug( "caveDeviceSimulatorDialog destroyed" );
}

void caveDeviceSimulatorDialog::open( QWidget* parent )
{
    m_dialog = new caveDeviceSimulatorDialog( parent );
    Tracer::debug( "caveDeviceSimulator opened" );
}
