#ifndef _EVENTMSG_H_
#define _EVENTMSG_H_
#include<pexpr/POMessage.h>

#ifdef WIN32
#ifdef REVENT_EXPORTS
#define REVENT_API __declspec(dllexport)
#else
#define REVENT_API __declspec(dllimport)
#endif /* REVENT_EXPORTS */
#else
#define REVENT_API
#endif /* WIN32 */

class DEvent;

//=============================================================================
/// @class EventMsg
/// @author Daniel Larimer
/// @brief Transports an event over the network.
///
/// The EventMsg class is used to send events using the message manager (PonyExpress).
//=============================================================================
class REVENT_API EventMsg : public POMessage
{
    public:
        EventMsg( const DEvent* evt = NULL );
        EventMsg( const EventMsg& cpy );
        ~EventMsg();

        string messageType()const { return "EventMsg"; }
        
        int packsize()const;
        int pack( char* buffer   )const;
        int unpack( char* buffer );

        POMessage* clone()const;
        
        DEvent* getEvent()const;
    private:
        DEvent* m_evt;
};


#endif
