#ifndef _CSCREATESEGMENTMSG_H_
#define _CSCREATESEGMENTMSG_H_
#include<pexpr/POMessage.h>
#include<pexpr/POTypes.h>
#include<string>
using namespace std;

#ifdef WIN32
#ifdef SHMMGR_EXPORTS
#define SHMMGR_API __declspec(dllexport)
#else
#define SHMMGR_API __declspec(dllimport)
#endif /* SHMMGR_EXPORTS */
#else
#define SHMMGR_API
#endif /* WIN32 */

//=============================================================================
/// @class CSCreateSegmentMsg
/// @brief Creates a message to request the creation of a memory segment.
//=============================================================================
class SHMMGR_API CSCreateSegmentMsg : public POMessage
{
    public:
        CSCreateSegmentMsg( const string& name = "NONE", int size = 0 );
        CSCreateSegmentMsg( const CSCreateSegmentMsg& cpy );
        virtual ~CSCreateSegmentMsg();
        
        virtual string messageType()const { return "CSCreateSegmentMsg"; };
        virtual POMessage* clone()const;

        string getSegmentName()const{ return m_sname.val();  }
        int    getSize()const       { return m_size.val();  }

        //==========================
        // Packable
        //==========================
        int packsize()const;
        int pack( char* buffer )const;
        int unpack( char* buffer );

    private:
        POString  m_sname;
        POInt     m_size;
};



#endif
