#ifndef _MEMORYSEGMENT_H_
#define _MEMORYSEGMENT_H_
#include<qobject.h>
#include<vector>
#include<string>
#include<pexpr/POAddress.h>

using namespace std;

#ifdef WIN32
#ifdef SHMMGR_EXPORTS
#define SHMMGR_API __declspec(dllexport)
#else
#define SHMMGR_API __declspec(dllimport)
#endif /* SHMMGR_EXPORTS */
#else
#define SHMMGR_API
#endif /* WIN32 */

class PostOffice;
class POBox;
class POTextMsg;
class MSWriteMsg;

//=============================================================================
/// @class MemorySegment
/// @brief A memory segment.
//=============================================================================
class SHMMGR_API MemorySegment : public QObject
{
    Q_OBJECT
    public:
        MemorySegment( PostOffice* po, const string& name, int size );
        ~MemorySegment();
        
        //=====================================
        // ShMem Interface
        //=====================================
        void   read ( char* buffer, int start, int size )const;
        void   write( char* buffer, int start, int size );
        int    size()const;
        string name()const;
        //=====================================
    
    public slots:
        void handleMessage();
        void resize( int x );

    signals: 
        void changed( const string& name, char* buffer, int start, int size );
        void changed();

    private:
        void handleConnect( const POTextMsg* msg );
        void handleDisconnect( const POTextMsg* msg );
        void handleWrite( const MSWriteMsg* msg );

        char* m_memory;
        int   m_size;
        POBox* m_box;

        string m_name;
        vector<POAddress> m_connections;
};

#endif
