//=============================================================================
/// @class NavMgrPanel
/// @brief provides an editor for the plugin mgr
/// @author Daniel Larimer
//=============================================================================
#ifndef _PLUGINMGRPANEL_H_
#define _PLUGINMGRPANEL_H_
#include<dmath/dmath.h>
#include<qtutil/PanelWidget.h>
#include<dutil/ColonList.h>
#include<map>
using namespace std;

#ifdef WIN32
#ifdef NAVMGRPANEL_EXPORTS
#define NAVMGRPANEL_API __declspec(dllexport)
#else
#define NAVMGRPANEL_API __declspec(dllimport)
#endif /* NAVMGRPANEL_EXPORTS */
#else
#define NAVMGRPANEL_API
#endif /* WIN32 */

class Plugin;
class QTabWidget;
class QListView;
class QCheckListItem;
class QListViewItem;
class PathEditWidget;

class NAVMGRPANEL_API NavMgrPanel : public PanelWidget
{
    Q_OBJECT
    public:
        NavMgrPanel( QWidget* parent = NULL );

        PanelWidget* clone( QWidget* parent = NULL )const;
    
    public slots:
        void updatePath( const string& );
        void addDir    ( const string& );
        void removeDir ( const string& );
        void updateNavigations();
        void itemClicked( QListViewItem* item );
     
    private:
        PathEditWidget*               m_pedit;
        QListView*                    m_pllist;
        QTabWidget*                   m_tabs;
        ColonList                     m_path;
        map<QCheckListItem*, Plugin*> m_itemmap;
};

#endif
