//=============================================================================
/// @class PluginMgrPanel
/// @brief provides an editor for the plugin mgr
/// @author Daniel Larimer
//=============================================================================
#ifndef _PLUGINMGRPANEL_H_
#define _PLUGINMGRPANEL_H_
#include<qtutil/PanelWidget.h>
#include<dutil/ColonList.h>
#include<map>
using namespace std;

class Plugin;
class QTabWidget;
class QListView;
class QCheckListItem;
class QListViewItem;
class PathEditWidget;

class PluginMgrPanel : public PanelWidget
{
    Q_OBJECT
    public:
        PluginMgrPanel( QWidget* parent = NULL );

        PanelWidget* clone( QWidget* parent = NULL )const;
    
    public slots:
        void updatePath( const string& path );
        void itemClicked( QListViewItem* item );
     
    private:
        PathEditWidget*               m_pedit;
        QListView*                    m_pllist;
        QTabWidget*                   m_tabs;
        ColonList                     m_path;
        map<QCheckListItem*, Plugin*> m_itemmap;
};

#endif
