#include"CaveWalls.h"
#include<iostream>
#include<GL/gl.h>
#include<GL/glu.h>
#ifdef WIN32
#include <GL/glext.h>
#endif
#include<tracer/Tracer.h>

using namespace std;

REGISTER_PLUGIN(CaveWalls)

CaveWalls::CaveWalls( const string& name )
:DGLAugment( name )
{
    setDescription("Display the walls of the DIVERSE unit cube.");
}

void CaveWalls::preNavDraw()const
{
    glPushMatrix();
    glPushAttrib(GL_CURRENT_BIT | GL_ENABLE_BIT | GL_LINE_BIT);

    glEnable(GL_DEPTH_TEST);
    glDisable(GL_LIGHTING);
    glDisable(GL_LINE_SMOOTH);
    glDisable(GL_LINE_STIPPLE);
    glDisable(GL_TEXTURE_1D);
    glDisable(GL_TEXTURE_2D);
    glDisable(GL_TEXTURE_3D);
    glLineWidth(3.0f);
    glColor4f( 1, 1, 1, 1);
    glBegin(GL_LINE_LOOP);
      glVertex3f(1.0f, -1.0f, -1.0f);
      glVertex3f(1.0f,  1.0f, -1.0f);
      glVertex3f(1.0f,  1.0f,  1.0f);
      glVertex3f(1.0f, -1.0f,  1.0f);
    glEnd();
    
    glBegin(GL_LINE_LOOP);
      glVertex3f(-1.0f, -1.0f, -1.0f);
      glVertex3f(-1.0f,  1.0f, -1.0f);
      glVertex3f(-1.0f,  1.0f,  1.0f);
      glVertex3f(-1.0f, -1.0f,  1.0f);
    glEnd();
    
    glBegin(GL_LINES);
      glVertex3f( 1.0f, -1.0f, -1.0f);
      glVertex3f(-1.0f, -1.0f, -1.0f);
      glVertex3f( 1.0f,  1.0f, -1.0f);
      glVertex3f(-1.0f,  1.0f, -1.0f);
      glVertex3f( 1.0f,  1.0f,  1.0f);
      glVertex3f(-1.0f,  1.0f,  1.0f);
      glVertex3f( 1.0f, -1.0f,  1.0f);
      glVertex3f(-1.0f, -1.0f,  1.0f);
    glEnd();
    glPopAttrib();
	glPopMatrix();
}

void CaveWalls::postProcess()
{
}








#include <dgl/libdgl/cdgl.h>
#include <GL/gl.h>

void display()
{
	static float angle1 = 0.0f;
	static float angle2 = 0.0f;
	static float angle3 = 0.0f;

	glClearColor( 0.0, 0.0, 0.0 , 0.0);
	//Do not uncomment until you specify
	//what you are clearing
	//glClear();

	glEnable( GL_DEPTH_TEST );
	glPolygonMode( GL_BACK, GL_LINE );
	glTranslatef( 0.0f, 10.0f, 0.0f );
	glRotatef( angle1, 0.0f, 0.0f, 1.0f );
	glRotatef( angle2, 1.0f, 0.0f, 0.0f );
	glRotatef( angle3, 0.0f, 1.0f, 0.0f );

	glBegin( GL_QUADS );
	glColor3f( 1.0f, 0.0f, 0.0f );
	glVertex3f( -1.0f, -1.0f, -1.0f );
	glColor3f( 0.0f, 1.0f, 0.0f );
	glVertex3f( 1.0f, -1.0f, -1.0f );
	glColor3f( 0.0f, 0.0f, 1.0f );
	glVertex3f( 1.0f, -1.0f, 1.0f );
	glColor3f( 1.0f, 1.0f, 1.0f );
	glVertex3f( -1.0f, -1.0f, 1.0f );
	glEnd();

	angle1 += 0.1f;
	angle2 += 0.2f;
	angle3 += abs(angle2) < 0.01f ? 0.01f : angle1 / angle2;
}

int main( int argc, char** argv )
{
	dglInit( argc, argv );
	dglDisplayCallback ( display );
	bool IWANTCONTROL=false;
	if (!IWANTCONTROL)
		dglRun();
	else
	{
		dglStart();
		while (dglIsRunning())
		{
			//Use the sync in case you need it
			dglSync();
			dglFrame();
		}
	}
}
