//=============================================================================
// mouseNavAid.h
// - Navigation plugin class to warp cursor to center of screen on mouse press
//     and display crosshair and pointer
//
// Created 6/29/03 By Patrick Shinpaugh
//=============================================================================

#ifndef _MOUSENAVAID_H_
#define _MOUSENAVAID_H_
#include <dgl/dglcore/DGLAugment.h>
#include <eventmgr/EventListener.h>

#ifdef WIN32
#ifdef MOUSENAVAID_EXPORTS
#define MOUSENAVAID_API __declspec(dllexport)
#else
#define MOUSENAVAID_API __declspec(dllimport)
#endif /* MOUSENAVAID_EXPORTS */
#else
#define MOUSENAVAID_API
#endif /* WIN32 */

class MOUSENAVAID_API mouseNavAid:public DGLAugment, public EventListener
{
    public:
        mouseNavAid( const string& name = "mouseNavAid" );
        virtual void postdraw()const;
        virtual bool onMouseEvent( DMouseEvent* evt );
private:
        int m_mousex;
        int m_mousey;
        int m_transdeadzone;
        int m_rotdeadzone;
        bool m_visible;
};

#endif
