#include"QDDisplay.h"
#include<qtutil/QDWindow.h>
#include<qtutil/QServiceManager.h>
#ifdef WIN32
#include <fontmgr/FontManager.h>
#endif

REGISTER_PLUGIN(QDDisplay)

QDDisplay::QDDisplay()
    :Plugin("QDDisplay")
{
    m_window = NULL;
}

//=============================================================================
// Function Name: load
///     Loads all dependencies before creating and showing a QDWindow
//=============================================================================
void QDDisplay::load()
{
    if( isLoaded() )
        return;
    Plugin::load();

    QServiceManager::init();
    m_window = new QDWindow();
    m_window->setCaption( "QDDisplay" );
    m_window->show();
}   

void QDDisplay::unload()
{
    Plugin::unload();
    m_window->hide();
    delete m_window;
}
