#include <dmath/dVec3.h>
#include <pexpr/POMessage.h>
#include <dcollab/core/collabmanager.h>
#include <servicemgr/GServiceManager.h>
#include <dcollab/core/avatarmessagehandler.h>
#include <dcollab/core/radarmessagehandler.h>
#include <dcollab/dcoin/coincreator.h>
#include <dcollab/core/2dradar.h>
#include <dcollab/core/avataraction.h>
#include <dcollab/core/radaraction.h>
#include <dcollab/dcoin/DGLDAR.h>
#include "coincollab.h"

REGISTER_PLUGIN(coinCollab);

coinCollab::coinCollab():Plugin("coinCollab")
{
	setDescription("Collaborative plugin for coin avatars");
}
coinCollab::~coinCollab()
{

}

void coinCollab::load()
{
	Plugin::load();
	//Init collaboration
	CollabManager::init();
	//Add in avatar actions for the client
	AvatarAction* AACtion = new AvatarAction;
	CollabManager::addAction(AACtion);

	//Setup avatar message handling for the client
	AvatarMessageHandler* AVHandler;
	AVHandler = new AvatarMessageHandler;

	//Setup radar message handling for the client
	RadarMessageHandler* RHandler;
	RHandler =new RadarMessageHandler;


	//Now setup the coin avatar creator
	CoinCreator*  MyCreat;
	MyCreat = new CoinCreator;
	ObjectCreator* NewCreat;
	NewCreat = new ObjectCreator;
	NewCreat->setCreator(MyCreat);
	AVHandler->setCreator(NewCreat);

	//Create the radar
	TwoDRadar* Radar;
	Radar = new TwoDRadar;
	Radar->setRadius(40);
	Radar->addPointType("avatar_type");
	//Add the radar to dgl
	DGLDAR* DarnOpengl = new DGLDAR;
	//Give the radar backend to the components that
	//need access to it
	DarnOpengl->setRadar(Radar);
	RHandler->setRadar(Radar);

	//Setup the radar action
	RadarAction* RAction = new RadarAction;
	RAction->setRadar(Radar);
	CollabManager::addAction(RAction);

	//END RADAR
	//Finally hand off everything to the collab manager
	CollabManager::addMessageHandler(AVHandler);
	CollabManager::addMessageHandler(RHandler);

	//Connect to the server
	string ConnectTo; 
	char* TName = getenv("DIVERSE_CSERVER");
	if (TName == NULL)
	{
		Tracer::error("Servername not specified, please specify which server to connect to");
		return;
	}
	else
		ConnectTo = string(TName);

	CollabManager::connectToServer(ConnectTo);
	//Load services to make things work
	PluginManager::loadPlugin("collabService");
	//GServiceManager::load("collabService");
	GServiceManager::startService("collabService");
}

void coinCollab::unload()
{
	Plugin::unload();
	CollabManager::disconnectFromServer();
}
