#include <dmath/dVec3.h>
#include <pexpr/POMessage.h>
#include <servicemgr/GServiceManager.h>
#include <dcollab/core/avatarmessagehandler.h>
#include <dcollab/dosg/osgcreator.h>
#include <dcollab/core/collabmanager.h>
#include <dcollab/core/avataraction.h>
#include "osgcollab.h"

REGISTER_PLUGIN(dosgCollab);

dosgCollab::dosgCollab():Plugin("dosgCollab")
{
	setDescription("Collaborative plugin for coin avatars");
}
dosgCollab::~dosgCollab()
{

}

void dosgCollab::load()
{
	Plugin::load();
	//Init collaboration
	CollabManager::init();
	AvatarAction* AACtion =new AvatarAction;
	CollabManager::addAction(AACtion);
	//Setup avatar message handling
	AvatarMessageHandler* AVHandler;
	AVHandler = new AvatarMessageHandler;
	//Now setup the coin avatar creator
	OsgCreator*  MyCreat;
	MyCreat = new OsgCreator;
	ObjectCreator* NewCreat;
	NewCreat = new ObjectCreator;
	NewCreat->setCreator(MyCreat);
	AVHandler->setCreator(NewCreat);
	//Finally hand off everythign to the collab manager
	CollabManager::addMessageHandler(AVHandler);
	//string ConnectTo = "mindy.sv.vt.edu";
	string ConnectTo;
	char* TName = getenv("DIVERSE_CSERVER");
	if (TName == NULL)
	{
		Tracer::error("Servername not specified, please specify which server to connect to");
		return;
	}
	else
		ConnectTo = string(TName);

	CollabManager::connectToServer(ConnectTo);
	PluginManager::loadPlugin("collabService");
	GServiceManager::startService("collabService");
}

void dosgCollab::unload()
{
	Plugin::unload();
	CollabManager::disconnectFromServer();
}
