#include <dtk.h>
#include <eventmgr/EventManager.h>
#include <tracer/Tracer.h>
#include <servicemgr/GServiceManager.h>
#include "dtkht.h"

dtkht::dtkht():GService("dtkht")
{
    Tracer::init();
    GServiceManager::addService( this );
    //Create the memory segments for the head, wand, buttons, and joystick
	m_head_segment = new dtkSharedMem(sizeof(float) * 6, "head");
    //Initalize the class arrays to zero
	for (int i=0; i<5; i++)
	{
		m_temph[i] = 0;
        m_head[i] = 0;
	}
	if (m_head_segment ==NULL )
		Tracer::error("Could not connect to the head, do not trust program results\n");
}

void dtkht::preProcess()
{
	//Get Data from shared memory
	m_head_segment->read(m_temph);
	bool Diff = false;
	//Did something change?
	for (int i=0; i<6; i++)
	{
		if  (m_temph[i] != m_head[i])
			Diff = true;
	}
	//If something changed
	if (Diff)
	{
        Tracer::stat("Head tracker moved");
		//Fire off a dgl event
		dVec3 XYZ;
		dVec3 HPR;
		for (int i=0; i<3; i++)
		{
			XYZ[i] = m_temph[i];
			HPR[i] = m_temph[i+3];
		}
        cout<<"new TrackerEvent\n";
        DTrackerEvent* Temp = new DTrackerEvent("headtracker", XYZ, HPR);
		EventManager::pushEvent(Temp);
		//Update the position so that I don't spew unless I have to 
        memcpy( m_head, m_temph, 6*sizeof(float) );
	}
}
