#ifndef DTKHT_H
#define DTKHT_H
#include <servicemgr/GService.h>
#include <dmath/dVec3.h>
#include <eventmgr/devents.h>
#include <string>

#ifdef WIN32
#ifdef DTKHT_EXPORTS
#define DTKHT_API __declspec(dllexport)
#else
#define DTKHT_API __declspec(dllimport)
#endif /* DTKHT_EXPORTS */
#else
#define DTKHT_API
#endif /* WIN32 */

class dtkSharedMem;

using namespace std;
//This class polls dtk head and wand events and then
//fires events to dgl
class DTKHT_API dtkht : public GService
{
    public:
        dtkht();
        virtual void preProcess();
        virtual void postProcess(){}
        void load();
       
        void postConfig(){};
        void preConfig(){};
        void config(){};
    
    private:
        //Make a wand event
        DWandEvent* MakeEvent(dVec3& XYZ, dVec3& HPR,
                              DWandEvent::ACTION Type, 
                              const string& Description);
        //Pointers to the dtk shared memory and 
        dtkSharedMem* m_head_segment;
        float m_head[6];
        float m_temph[6];
};
#endif
