#include"DtkManagerService.h"
#include <dtk/__manager_magicNums.h>
#include<stdlib.h>
#include <dreg/Registry.h>
#include<servicemgr/GServiceManager.h>
using namespace std;

DtkManagerService::DtkManagerService()
:GService( "DtkManager" )
{
    m_mgr = new dtkManager();
    GServiceManager::addService(this);
    char* augments = getenv("DTK_DSO_FILES");
    char* path     = getenv("DTK_DSO_PATH");

    dtkNavList* nav = new dtkNavList;
    m_mgr->add(nav);

    if( path )
    {
        Tracer::stat( 3, "DTK_DSO_PATH = %s", path );
        m_mgr->path(path);
    }
    if( augments )
    {
        Tracer::stat( 1, "DTK_DSO_FILES = %s", augments );
        m_mgr->load(augments);
    }
    //m_mgr->load("caveDTKInput");
    //m_mgr->load("wandJoystickNav");
    /*
    m_mgr->load("xkeyboardMouseInput");
    m_mgr->load("iconSleepKeyboardMod");
    m_mgr->load("trackballNav");
    m_mgr->load("desktopFlyNav");
    m_mgr->load("desktopHoverNav");
    m_mgr->load("keyboardNavControl");
    */
    //nav->add((dtkNav*)m_mgr->get("wandJoystickNav", DTKNAV_TYPE));
    //Load in the augments listed in the configuration file
    Entry* Augments = Registry::getEntry("/DTK/augments");
    if (Augments == NULL)
        Tracer::error("No dtk augments listed, prepare for crash\n");
    map<string, Entry*> DTKAugments = Augments->getEntries();
    map<string, Entry*>::iterator itr = DTKAugments.begin();
    while (itr !=DTKAugments.end())
    {
        if (itr->second->getValue( "",  "yes") == "yes")
        {
            m_mgr->load(itr->first.c_str());
        }
        itr++;
    }
    
}

void DtkManagerService::preConfig()
{
    m_mgr->preConfig();
}

void DtkManagerService::config()
{
    m_mgr->config();
}

void DtkManagerService::postConfig()
{
    m_mgr->postConfig();
}

void DtkManagerService::sync()
{
    m_mgr->sync();
}

void DtkManagerService::preProcess()
{
    m_mgr->preFrame(__DTKMANAGER_PREFRAME_MAGIC_);
}

void DtkManagerService::frame()
{
    m_mgr->frame();
}

void DtkManagerService::postProcess()
{
    m_mgr->postFrame(__DTKMANAGER_POSTFRAME_MAGIC_);
}
