//=============================================================================
/// @class DtkManagerService
/// @brief Hooks in DTK Augments 
/// @author Daniel Larimer
//=============================================================================
#ifndef _DTKMANAGERSERVICE_H_
#define _DTKMANAGERSERVICE_H_
#include<servicemgr/GService.h>
#include<pluginmgr/Plugin.h>
#include<dtk.h>

#ifdef WIN32
#ifdef DTKMGR_EXPORTS
#define DTKMGR_API __declspec(dllexport)
#else
#define DTKMGR_API __declspec(dllimport)
#endif /* DTKMGR_EXPORTS */
#else
#define DTKMGR_API
#endif /* WIN32 */

class DTKMGR_API DtkManagerService : public GService
{
    public:
        DtkManagerService();
        dtkManager* getManager()const { return m_mgr; }
        
        virtual void preConfig();
        virtual void config();
        virtual void postConfig();

        virtual void sync();
        virtual void preProcess();
        virtual void frame();
        virtual void postProcess();
    private:
        dtkManager* m_mgr;
};

#endif
