#ifndef DTKWT_H
#define DTKWT_H

#define WAND_MOVEMENT "wand_movement"
#define HEAD_MOVEMENT "head_movement"
#define B_PRESS  "button_press"
#define B_RELEASE "button_release"
#define JOYSTICK_MOVE  "joystick_move"

#include <servicemgr/GService.h>
#include <dmath/dVec3.h>
#include <eventmgr/devents.h>
#include <string>

#ifdef WIN32
#ifdef DTKWT_EXPORTS
#define DTKWT_API __declspec(dllexport)
#else
#define DTKWT_API __declspec(dllimport)
#endif /* DTKWT_EXPORTS */
#else
#define DTKWT_API
#endif /* WIN32 */

class dtkSharedMem;

using namespace std;
//This class polls dtk head and wand events and then
//fires events to dgl
class DTKWT_API dtkwt: public GService
{
	public:
	dtkwt();
	virtual void postProcess();
    
	private:
    //Make a wand event
    DWandEvent* MakeEvent(dVec3& XYZ, dVec3& HPR, DWandEvent::ACTION Type, const string& Description);
	//Pointers to the dtk shared memory and 
	dtkSharedMem*  m_wand_segment;
	dtkSharedMem*  m_button_segment;
	dtkSharedMem*  m_joystick_segment;
	float m_wand[6];
	int m_buttons[4];
	float  m_joystick[4];

	float m_tempw[6];
	int   m_tempb[4];
	float m_tempj[2];
};
#endif
