#ifndef _IS900_H_
#define _IS900_H_
#include<dmath/dmath.h>
#include <servicemgr/GService.h>
#include <eventmgr/devents.h>
#include <dmath/dMatrix.h>
#include <dutil/DTime.h>
#include <map>
#include "is900config.h"

#if (SWAPBYTES)
static float getFloat( unsigned char * b )
{
    float *fp;
    char   s[4];
    s[3] = b[0];
    s[2] = b[1];
    s[1] = b[2];
    s[0] = b[3];
    fp = (float*)( s );
    return( *fp );
}
#else
#define getFloat(x)  (*(float *)(x))
#endif

class IS900:public GService
{
    public:
        IS900( const string& name = "IS900" );
        virtual ~IS900();
        virtual void preProcess();
        virtual void postProcess(const DTime&) {};
    private:
        void clean_up(void);

        DEvent *m_tracker_event[NUM_STATIONS];
        DEvent *m_buttons_event;
        DEvent *m_joystick_event;

#ifdef CALIBRATE
        DEvent *m_cal_event;
        float m_offset[6];
#endif

        int m_fd;
        
        dVec3 m_statepos[NUM_STATIONS];
        dVec3 m_statedir[NUM_STATIONS];

        unsigned char m_buffer[BUFFER_SIZE];
        unsigned char *m_ptr, *m_end;

        dMatrix m_transHead;
        
        DTime m_delta_time;

        float m_tolerance;

        bool m_buttons[4];
        float m_joystick[2];
        dVec3 m_headpos[2];
        dVec3 m_headdir[2];
        dVec3 m_wandpos[2];
        dVec3 m_wanddir[2];
};

#endif

